<?php

/*
 * ELMA rsyslog setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/apache-default-authentication.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Apache authentication setup";

$SERVICE_SYSTEMD_NAME = "apache2.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --apache';

$SERVICE_ENABLED_LABEL = "Include configuration file";
$SERVICE_ENABLED_NAME = "APACHE2_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable basic password authentication or allowed client IP addresses";
$SERVICE_ENABLED_ACTION = 'if [ -f /etc/apache2/conf.d/default-authentication.conf ]; then echo "Yes"; fi';

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "APACHE2_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Apache Webserver (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Include configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/apache2/default-server.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "Configuration snippet";
$SERVICE_CONFIG_2_FILE = "/etc/apache2/conf.d/default-authentication.conf";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Apache access log";
$SERVICE_LOG_2_FILE = "/var/log/apache2/access_log";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SERVICE_LOG_3_LABEL = "Apache ssl request log";
$SERVICE_LOG_3_FILE = "/var/log/apache2/ssl_request_log";
$SERVICE_LOG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_3_FILE;
$SERVICE_LOG_3_HELP = $SERVICE_LOG_3_FILE;

$SERVICE_LOG_4_LABEL = "Apache error log";
$SERVICE_LOG_4_FILE = "/var/log/apache2/error_log";
$SERVICE_LOG_4_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_4_FILE;
$SERVICE_LOG_4_HELP = $SERVICE_LOG_4_FILE;

$SYSCONFIG_1_LABEL = "APACHE2_AUTH_BASIC_PROVIDER";
$SYSCONFIG_1_NAME = "APACHE2_AUTH_BASIC_PROVIDER";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>Basic authentication provider(s)</p><ol style="list-style-type:disc";><li>Possible provider combinations (seperated with a blank):<p><ol style="list-style-type:none";><li>file</li><li>file ldap</li><li>file xradius</li><li>file ldap xradius</li></ol></p><li>Default value: file</li></ol>';

$SYSCONFIG_2_LABEL = "APACHE2_AUTH_LDAP_URL";
$SYSCONFIG_2_NAME = "APACHE2_AUTH_LDAP_URL";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>Specifies the LDAP server, the base DN, the attribute to use in the search, as well as the extra search filter to use for LDAP authentication provider(s).</p><ol style="list-style-type:disc";><li>Example: ldaps://ldap01.example.com ldap02.example.com/OU=Users,DC=example,DC=com?sAMAccountName?sub?(objectClass=*)</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_3_LABEL = "APACHE2_AUTH_LDAP_BIND_DN";
$SYSCONFIG_3_NAME = "APACHE2_AUTH_LDAP_BIND_DN";
$SYSCONFIG_3_TYPE = "text";
$SYSCONFIG_3_CHANGE = "enabled";
$SYSCONFIG_3_HELP = '<p>An optional DN to bind with during the search phase for LDAP authentication provider(s).</p><ol style="list-style-type:disc";><li>Example: CN=_ldapbinduser,OU=Users,DC=example,DC=com</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_4_LABEL = "APACHE2_AUTH_LDAP_BIND_PASSWORD";
$SYSCONFIG_4_NAME = "APACHE2_AUTH_LDAP_BIND_PASSWORD";
$SYSCONFIG_4_TYPE = "text";
$SYSCONFIG_4_CHANGE = "enabled";
$SYSCONFIG_4_HELP = '<p>An optional password to bind with during the search phase for LDAP authentication provider(s).</p><ol style="list-style-type:disc";><li>Example: MyLDAPPassword</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_5_LABEL = "APACHE2_AUTH_XRADIUS_SERVER";
$SYSCONFIG_5_NAME = "APACHE2_AUTH_XRADIUS_SERVER";
$SYSCONFIG_5_TYPE = "text";
$SYSCONFIG_5_CHANGE = "enabled";
$SYSCONFIG_5_HELP = '<p>IP addresses from your RADIUS servers seperated with a blank for xRADIUS authentication provider(s).</p><ol style="list-style-type:disc";><li>Example: 1.1.1.1 2.2.2.2</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_6_LABEL = "APACHE2_AUTH_XRADIUS_PORT";
$SYSCONFIG_6_NAME = "APACHE2_AUTH_XRADIUS_PORT";
$SYSCONFIG_6_TYPE = "text";
$SYSCONFIG_6_CHANGE = "enabled";
$SYSCONFIG_6_HELP = '<p>Listening port of your RADIUS servers for xRADIUS authentication provider(s).</p><ol style="list-style-type:disc";><li>Default value: 1645</li></ol>';

$SYSCONFIG_7_LABEL = "APACHE2_AUTH_XRADIUS_KEY";
$SYSCONFIG_7_NAME = "APACHE2_AUTH_XRADIUS_KEY";
$SYSCONFIG_7_TYPE = "text";
$SYSCONFIG_7_CHANGE = "enabled";
$SYSCONFIG_7_HELP = '<p>Shared secret of your RADIUS servers for xRADIUS authentication provider(s).</p><ol style="list-style-type:disc";><li>Example: MyRadiusKey</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_8_LABEL = "APACHE2_AUTH_XRADIUS_TIMEOUT";
$SYSCONFIG_8_NAME = "APACHE2_AUTH_XRADIUS_TIMEOUT";
$SYSCONFIG_8_TYPE = "text";
$SYSCONFIG_8_CHANGE = "enabled";
$SYSCONFIG_8_HELP = '<p>Time in seconds to wait for replies from your RADIUS servers for xRADIUS authentication provider(s).</p><ol style="list-style-type:disc";><li>Default value: 7</li></ol>';

$SYSCONFIG_9_LABEL = "APACHE2_AUTH_XRADIUS_RETRIES";
$SYSCONFIG_9_NAME = "APACHE2_AUTH_XRADIUS_RETRIES";
$SYSCONFIG_9_TYPE = "text";
$SYSCONFIG_9_CHANGE = "enabled";
$SYSCONFIG_9_HELP = '<p>Number of times to resend a request to your RADIUS server if no reply is received for xRADIUS authentication provider(s).</p><ol style="list-style-type:disc";><li>Default value: 2</li></ol>';

include("form.inc");

?>
