<?php

/*
 * ELMA rsyslog setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/apache-kibana3.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Kibana GUI";

$SERVICE_SYSTEMD_NAME = "apache2.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --apache';

$SERVICE_ENABLED_LABEL = "Include configuration file";
$SERVICE_ENABLED_NAME = "APACHE2_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable Kibana GUI";
$SERVICE_ENABLED_ACTION = 'if [ -f /etc/apache2/conf.d/kibana3.conf ]; then echo "Yes"; fi';

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "APACHE2_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Apache Webserver (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Include configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/apache2/default-server.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "Configuration snippet";
$SERVICE_CONFIG_2_FILE = "/etc/apache2/conf.d/kibana3.conf";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Apache access log";
$SERVICE_LOG_2_FILE = "/var/log/apache2/access_log";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SERVICE_LOG_3_LABEL = "Apache ssl request log";
$SERVICE_LOG_3_FILE = "/var/log/apache2/ssl_request_log";
$SERVICE_LOG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_3_FILE;
$SERVICE_LOG_3_HELP = $SERVICE_LOG_3_FILE;

$SERVICE_LOG_4_LABEL = "Apache error log";
$SERVICE_LOG_4_FILE = "/var/log/apache2/error_log";
$SERVICE_LOG_4_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_4_FILE;
$SERVICE_LOG_4_HELP = $SERVICE_LOG_4_FILE;

include("form.inc");

?>
