<?php

/*
 * ELMA Apache setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/apache.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Apache setup";

$SERVICE_SYSTEMD_NAME = "apache2.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --apache';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "APACHE2_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable Apache Webserver (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "APACHE2_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Apache Webserver (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Include configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/apache2/httpd.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "Configuration snippet";
$SERVICE_CONFIG_2_FILE = "/etc/apache2/listen.conf";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_CONFIG_3_LABEL = "Configuration snippet";
$SERVICE_CONFIG_3_FILE = "/etc/apache2/default-server.conf";
$SERVICE_CONFIG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_3_FILE;
$SERVICE_CONFIG_3_HELP = $SERVICE_CONFIG_3_FILE;

$SERVICE_CONFIG_4_LABEL = "Configuration snippet";
$SERVICE_CONFIG_4_FILE = "/etc/apache2/conf.d/mod_status.conf";
$SERVICE_CONFIG_4_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_4_FILE;
$SERVICE_CONFIG_4_HELP = $SERVICE_CONFIG_4_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Apache access log";
$SERVICE_LOG_2_FILE = "/var/log/apache2/access_log";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SERVICE_LOG_3_LABEL = "Apache ssl request log";
$SERVICE_LOG_3_FILE = "/var/log/apache2/ssl_request_log";
$SERVICE_LOG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_3_FILE;
$SERVICE_LOG_3_HELP = $SERVICE_LOG_3_FILE;

$SERVICE_LOG_4_LABEL = "Apache error log";
$SERVICE_LOG_4_FILE = "/var/log/apache2/error_log";
$SERVICE_LOG_4_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_4_FILE;
$SERVICE_LOG_4_HELP = $SERVICE_LOG_4_FILE;

$SYSCONFIG_1_LABEL = "Authentication";
$SYSCONFIG_1_NAME = "";
$SYSCONFIG_1_TYPE = "checkbox";
$SYSCONFIG_1_CHANGE = "disabled";
$SYSCONFIG_1_HELP = '<p>Basic password authentication or allowed client IP addresses</p>';
$SYSCONFIG_1_ACTION = 'if [ -f /etc/apache2/conf.d/default-authentication.conf ]; then echo "Yes"; fi';

$SYSCONFIG_2_LABEL = "Rewriting ruleset";
$SYSCONFIG_2_NAME = "";
$SYSCONFIG_2_TYPE = "checkbox";
$SYSCONFIG_2_CHANGE = "disabled";
$SYSCONFIG_2_HELP = '<p>Rewriting ruleset</p>';
$SYSCONFIG_2_ACTION = 'if [ -f /etc/apache2/conf.d/redirect-http.conf ]; then echo "Yes"; fi';

$SYSCONFIG_3_LABEL = "SSL";
$SYSCONFIG_3_NAME = "";
$SYSCONFIG_3_TYPE = "checkbox";
$SYSCONFIG_3_CHANGE = "disabled";
$SYSCONFIG_3_HELP = '<p>SSL</p>';
$SYSCONFIG_3_ACTION = 'if [ -f /etc/apache2/conf.d/default-ssl.conf ]; then echo "Yes"; fi';

$SYSCONFIG_4_LABEL = "PHP";
$SYSCONFIG_4_NAME = "";
$SYSCONFIG_4_TYPE = "checkbox";
$SYSCONFIG_4_CHANGE = "disabled";
$SYSCONFIG_4_HELP = '<p>PHP</p>';
$SYSCONFIG_4_ACTION = 'if [ -f /etc/apache2/conf.d/php5.conf ]; then echo "Yes"; fi';

$SYSCONFIG_5_LABEL = "ElasticSearch REST API";
$SYSCONFIG_5_NAME = "";
$SYSCONFIG_5_TYPE = "checkbox";
$SYSCONFIG_5_CHANGE = "disabled";
$SYSCONFIG_5_HELP = '<p>ElasticSearch REST API</p>';
$SYSCONFIG_5_ACTION = 'if [ -f /etc/apache2/conf.d/elasticsearch.conf ]; then echo "Yes"; fi';

$SYSCONFIG_6_LABEL = "Kibana GUI";
$SYSCONFIG_6_NAME = "";
$SYSCONFIG_6_TYPE = "checkbox";
$SYSCONFIG_6_CHANGE = "disabled";
$SYSCONFIG_6_HELP = '<p>Kibana GUI</p>';
$SYSCONFIG_6_ACTION = 'if [ -f /etc/apache2/conf.d/kibana3.conf ]; then echo "Yes"; fi';

$SYSCONFIG_7_LABEL = "Nagios GUI";
$SYSCONFIG_7_NAME = "";
$SYSCONFIG_7_TYPE = "checkbox";
$SYSCONFIG_7_CHANGE = "disabled";
$SYSCONFIG_7_HELP = '<p>Nagios GUI</p>';
$SYSCONFIG_7_ACTION = 'if [ -f /etc/apache2/conf.d/nagios.conf ]; then echo "Yes"; fi';

$SYSCONFIG_8_LABEL = "webmin GUI";
$SYSCONFIG_8_NAME = "";
$SYSCONFIG_8_TYPE = "checkbox";
$SYSCONFIG_8_CHANGE = "disabled";
$SYSCONFIG_8_HELP = '<p>webmin GUI</p>';
$SYSCONFIG_8_ACTION = 'if [ -f /etc/apache2/conf.d/webmin.conf ]; then echo "Yes"; fi';

include("form.inc");

?>
