<?php

/*
 * ELMA Cron setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/cron.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Cron setup";

$SERVICE_SYSTEMD_NAME = "cron.service";

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "CRON_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable cron the time-based command scheduler (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "CRON_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of cron the time-based command scheduler (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "System crontab";
$SERVICE_CONFIG_1_FILE = "/etc/crontab";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Config backup";
$SERVICE_LOG_2_HELP = "Cron job to make a system configuration backup";
$SERVICE_LOG_2_FILE = "/etc/cron.d/elma-config-backup.sh";
$SERVICE_LOG_2_ACTION = "sudo -u root -S ".$SERVICE_LOG_2_FILE;

$SERVICE_LOG_3_LABEL = "Delete old config backups";
$SERVICE_LOG_3_HELP = "Cron job to delete old system configuration backups";
$SERVICE_LOG_3_FILE = "/etc/cron.d/elma-delete-backup.sh";
$SERVICE_LOG_3_ACTION = "sudo -u root -S ".$SERVICE_LOG_3_FILE;

$SERVICE_LOG_4_LABEL = "Delete old elasticsearch indexes";
$SERVICE_LOG_4_HELP = "Cron job to delete old elasticsearch indexes";
$SERVICE_LOG_4_FILE = "/etc/cron.d/elma-elasticsearch.sh";
$SERVICE_LOG_4_ACTION = "sudo -u root -S ".$SERVICE_LOG_4_FILE;

$SYSCONFIG_1_LABEL = "SYSCONFIG_ARCHIVE_PERIOD";
$SYSCONFIG_1_NAME = "SYSCONFIG_ARCHIVE_PERIOD";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "disabled";
$SYSCONFIG_1_HELP = '<p>Number of days system configuration backup should be hold</p><ol style="list-style-type:disc";><li>Default value: 360</li></ol>';

$SYSCONFIG_2_LABEL = "ES_ARCHIVE_PERIOD";
$SYSCONFIG_2_NAME = "ES_ARCHIVE_PERIOD";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "disabled";
$SYSCONFIG_2_HELP = '<p>Number of days ElasticSearch indexes should be hold</p><ol style="list-style-type:disc";><li>Default value: 7</li></ol>';

include("form.inc");

?>
