<?php

/*
 * ELMA ElasticSearch setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/elasticsearch.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "ElasticSearch setup";

$SERVICE_SYSTEMD_NAME = "elasticsearch.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --elasticsearch';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "ES_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable elasticsearch server (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "ES_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of elasticsearch server (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/elasticsearch/elasticsearch.yml";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "Logging configuration file";
$SERVICE_CONFIG_2_FILE = "/etc/elasticsearch/logging.yml";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_CONFIG_3_LABEL = "ElasticSearch sysconfig";
$SERVICE_CONFIG_3_FILE = "/etc/sysconfig/elasticsearch";
$SERVICE_CONFIG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_3_FILE;
$SERVICE_CONFIG_3_HELP = $SERVICE_CONFIG_3_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "ElasticSearch log";
$SERVICE_LOG_2_FILE = 'grep "^ES_CLUSTER_NAME=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
$SERVICE_LOG_2_FILE = exec($SERVICE_LOG_2_FILE);
$SERVICE_LOG_2_FILE = "/var/log/elasticsearch/".$SERVICE_LOG_2_FILE.".log";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SYSCONFIG_1_LABEL = "ES_CLUSTER_NAME";
$SYSCONFIG_1_NAME = "ES_CLUSTER_NAME";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>Cluster name identifies your cluster for auto-discovery</p><ol style="list-style-type:disc";><li>If you are running multiple clusters on the same network, make sure you are using unique names.</li><li>Default value: elma</li></ol>';

$SYSCONFIG_2_LABEL = "ES_HEAP_SIZE";
$SYSCONFIG_2_NAME = "ES_HEAP_SIZE";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>ElasticSearch Heap Size (ES defaults to 256m min, 1g max)</p><ol style="list-style-type:disc";><li>Make sure that the ES_HEAP_SIZE environment variables is set and that the machine has enough memory to allocate for ElasticSearch, leaving enough memory for the operating system itself.</li><li>If you use the server(s) for Elasticsearch only, the rule of thumb is to allocate half the total RAM size to Elasticsearch. The other half would be used for system caches, which is important as well.</li><li>Recommendation: 2g</li><li>Default value: 256m</li></ol>';

$SYSCONFIG_3_LABEL = "ES_ARCHIVE_PERIOD";
$SYSCONFIG_3_NAME = "ES_ARCHIVE_PERIOD";
$SYSCONFIG_3_TYPE = "text";
$SYSCONFIG_3_CHANGE = "enabled";
$SYSCONFIG_3_HELP = '<p>Number of days ElasticSearch indexes should be hold</p><ol style="list-style-type:disc";><li>Default value: 7</li></ol>';

$SYSCONFIG_4_LABEL = "ES_DATA_DIR";
$SYSCONFIG_4_NAME = "ES_DATA_DIR";
$SYSCONFIG_4_TYPE = "text";
$SYSCONFIG_4_CHANGE = "enabled";
$SYSCONFIG_4_HELP = '<p>Path to directory where to store index data allocated for this node</p><ol style="list-style-type:disc";><li>Default value: /var/lib/elasticsearch</li></ol>';

$SYSCONFIG_5_LABEL = "ES_HOST";
$SYSCONFIG_5_NAME = "ES_HOST";
$SYSCONFIG_5_TYPE = "text";
$SYSCONFIG_5_CHANGE = "disabled";
$SYSCONFIG_5_HELP = '<p>ElasticSearch host</p><ol style="list-style-type:disc";><li>Not to be used as array for ElasticSearch cluster member!!!</li><li>Default value: localhost</li></ol>';

$SYSCONFIG_6_LABEL = "ES_PLUGIN_PROTOCOL";
$SYSCONFIG_6_NAME = "ES_PLUGIN_PROTOCOL";
$SYSCONFIG_6_TYPE = "text";
$SYSCONFIG_6_CHANGE = "disabled";
$SYSCONFIG_6_HELP = '<p>ElasticSearch http/ssl network communication</p><ol style="list-style-type:disc";><li>Protocol can be "http" or "https"</li><li>Default value: https</li></ol>';

$SYSCONFIG_7_LABEL = "ES_PLUGIN_PORT";
$SYSCONFIG_7_NAME = "ES_PLUGIN_PORT";
$SYSCONFIG_7_TYPE = "text";
$SYSCONFIG_7_CHANGE = "disabled";
$SYSCONFIG_7_HELP = '<p>ElasticSearch http/ssl network communication</p><ol style="list-style-type:disc";><li>Listening tcp port of apache webserver</li><li>Default value: 9443</li></ol>';

/*

# ######### Set ElasticSearch http localhost communication #########
#
# ElasticSearch port to listen for HTTP traffic
#
ES_PROTOCOL="http"
ES_PORT="9200"

# ######### Set ElasticSearch URL #########
#
ES_URL="--insecure --noproxy $ES_HOST $ES_PROTOCOL://$ES_HOST:$ES_PORT"

# ######### Set ElasticSearch Jetty HashLoginService passwd file #########
#
ES_PASSWD_FILE="/etc/elasticsearch/realm.properties"

# ######### Set ElasticSearch service UID and password #########
#
ES_UID="elma"
ES_PWD="fjg892345sdfsdwf4"

# ######### Enable curl basic elasticsearch authentication #########
#
# The site might require a different authentication method (check the headers
# returned by the server).
#
# --user
# --ntlm
# --digest
# --negotiate
# --anyauth
#
# might be options that suit you.
#
#ES_AUTH="-u $ES_UID:$ES_PWD"

# ######### Disable curl basic authentication #########
#
ES_AUTH=""

# ##########################################
#
# curl $ES_AUTH -s $ES_URL/path/doc.html
# curl $ES_AUTH -s -XDELETE $ES_URL/index/
# curl $ES_AUTH -XPOST $ES_URL/index/
# curl $ES_AUTH -s -XGET $ES_URL/$2
# curl $ES_AUTH -XGET $ES_URL/$2/
#
# ##########################################

# ######### Set ElasticSearch Jetty transport without filter #########
#
ES_HTTP_TYPE="com.sonian.elasticsearch.http.jetty.JettyHttpServerTransportModule"

# ######### Set ElasticSearch Jetty transport with filter #########
#
#ES_HTTP_TYPE="com.sonian.elasticsearch.http.filter.FilterHttpServerTransportModule"

# ######### Allow rsyslog event forwarding to ElasticSearch data nodes #########
#
# central rsyslog server with event frowarding to ElasticSearch data nodes
# (used by local rsyslogd service)
#
# ES_RSYSLOG_CENTRAL_SERVER="IP addresses from your central rsyslog servers seperated with a blank"
# ES_RSYSLOG_CENTRAL_SERVER="192.168.178.1 192.168.178.2 192.168.178.3"
#
ES_RSYSLOG_CENTRAL_SERVER=""
*/

include("form.inc");

?>

