<?php

/*
 * ELMA global setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/elma.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "ELMA setup";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --all';

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "3";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --config-status';

$SERVICE_CONFIG_1_LABEL = "Configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/elma/elma.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "sudoers";
$SERVICE_CONFIG_2_FILE = "/etc/sudoers";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_LOG_1_LABEL = "Patch configuration file";
$SERVICE_LOG_1_HELP = "Check differences between system and distribution configuration file";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --patch-config';

$SERVICE_LOG_2_LABEL = "Reset to factory defaults";
$SERVICE_LOG_2_HELP = "Reset ELMA configuration parameter to factory defaults";
$SERVICE_LOG_2_FILE = "";
$SERVICE_LOG_2_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --reset';

$SERVICE_LOG_3_LABEL = "System diagnostics";
$SERVICE_LOG_3_HELP = "System diagnostics - Check and repair file system";
$SERVICE_LOG_3_FILE = "";
$SERVICE_LOG_3_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --diag';

$SYSCONFIG_1_LABEL = "ELMA_MAIL_ADDRESS";
$SYSCONFIG_1_NAME = "ELMA_MAIL_ADDRESS";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>ELMA ServerAdmin</p><ol style="list-style-type:disc";><li>Example: webmaster@example.com</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_2_LABEL = "ELMA_WWW_FQDN";
$SYSCONFIG_2_NAME = "ELMA_WWW_FQDN";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>Apache ServerName</p><ol style="list-style-type:disc";><li>Example: yourloghost.example.com</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_3_LABEL = "SYSCONFIG_ARCHIVE_PERIOD";
$SYSCONFIG_3_NAME = "SYSCONFIG_ARCHIVE_PERIOD";
$SYSCONFIG_3_TYPE = "text";
$SYSCONFIG_3_CHANGE = "enabled";
$SYSCONFIG_3_HELP = '<p>Number of days system configuration backup should be hold</p><ol style="list-style-type:disc";><li>Default value: 360</li></ol>';

$SYSCONFIG_4_LABEL = "ELMA_ORGANIZATION_LOGO";
$SYSCONFIG_4_NAME = "ELMA_ORGANIZATION_LOGO";
$SYSCONFIG_4_TYPE = "text";
$SYSCONFIG_4_CHANGE = "enabled";
$SYSCONFIG_4_HELP = '<p>ELMA web gui header organization logo</p><ol style="list-style-type:disc";><li>Example: logo_elma.png</li><li>Default value: leave it to blank</li></ol><p>Copy your organization logo to below path</p><ol style="list-style-type:disc";><li>Format: png or gif</li><li>Height: 36px</li><li>Background: transparent</li></ol>';

include("form.inc");

?>

