<?php

/*
 * ELMA Firewall setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/firewall.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Firewall setup";

$SERVICE_SYSTEMD_NAME = "SuSEfirewall2.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --firewall';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "FW_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable SuSEfirewall (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "FW_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of SuSEfirewall (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Firewall sysconfig";
$SERVICE_CONFIG_1_FILE = "/etc/sysconfig/SuSEfirewall2";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Firewall log";
$SERVICE_LOG_2_FILE = "/var/log/firewall";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SYSCONFIG_1_LABEL = "FW_SERVICES_EXT_TCP";
$SYSCONFIG_1_NAME = "FW_SERVICES_EXT_TCP";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>Open necessary SuSEfirewall tcp ports</p><ol style="list-style-type:disc";><li>tcp/21 - ftp server<br>tcp/22 - system management<br>tcp/53 - ntp server<br>tcp/123 - ntp server<br>tcp/514 - rsyslog event input<br>tcp/4984 - webyast server<br>tcp/5544 - logstash JSON event input<br>tcp/80 - apache server<br>tcp/443 - apache server<br>tcp/9200-9299 - ElasticSearch HTTP traffic<br>tcp/9300-9399 - ElasticSearch node-to-node communication<br>tcp/9443 - ElasticSearch HTTPs traffic<br>tcp/32000 - ElasticSearch server</li></ol><ol style="list-style-type:disc";><li>Default value: 53 80 123 443 514 4984 5544 9200:9399 9443 32000</li></ol>';

$SYSCONFIG_2_LABEL = "FW_SERVICES_EXT_UDP";
$SYSCONFIG_2_NAME = "FW_SERVICES_EXT_UDP";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>Open necessary SuSEfirewall udp ports</p><ol style="list-style-type:disc";><li>udp/53 - ntp server<br>udp/123 - ntp server<br>udp/161 - snmpd<br>udp/162 - snmptrapd<br>udp/514 - rsyslog event input</li></ol><ol style="list-style-type:disc";><li>Default value: 53 123 161 162 514</li></ol>';

include("form.inc");

?>

