<?php

/*
 * ELMA setup form
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/form.inc
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

function ServiceAction($ACTION, $LABEL, $FILE){

	$ACTION_OUTPUT = "";
	$ERROR_OUTPUT = "";
	$OUTPUT = "";

	exec($ACTION, $OUTPUT, $ERROR);

	foreach($OUTPUT as $LINE) {
		$ACTION_OUTPUT = $ACTION_OUTPUT.htmlentities($LINE)."\n";
	}

	if ($ERROR != 0) $ERROR_OUTPUT = '<div class="alert alert-danger">Error during below action - Please check error messages!</div>';

	$RETURN_OUTPUT = '<a class="show_abstract">'.$LABEL.' '.$FILE.'</a>';
	$RETURN_OUTPUT = $RETURN_OUTPUT.'<div class="abs"><pre>'.$ACTION_OUTPUT.'</pre></div>';

	return array(
		$ERROR_OUTPUT,
		$RETURN_OUTPUT,
	);
}

function ReconfigureAction($NAME, $VALUE, $FILE){

	$VALUE=str_replace("&", "\&", $VALUE);

	if ($FILE == "/etc/sysconfig/network/config") {
		$ACTION = 'sudo -u root -S touch '.$FILE;
		shell_exec($ACTION);

		$ACTION = 'sudo -u root -S chown wwwrun /etc/sysconfig/network';
		shell_exec($ACTION);

		$ACTION = 'sudo -u root -S chown wwwrun '.$FILE;
		shell_exec($ACTION);

		$ACTION = 'sed -i -e \'/^'.$NAME.'=/s|=.*|="'.$VALUE.'"|\' '.$FILE;
		shell_exec($ACTION);

		$ACTION = 'sudo -u root -S chown root '.$FILE;
		shell_exec($ACTION);

		$ACTION = 'sudo -u root -S chown root /etc/sysconfig/network';
		shell_exec($ACTION);
	} else {
		$ACTION = 'sed -i -e \'/^'.$NAME.'=/s|=.*|=\x27'.$VALUE.'\x27|\' '.$FILE;
		shell_exec($ACTION);
	}
}

function EditConfigFileAction($VALUE, $FILE){

	$ACTION = 'sudo -u root -S touch '.$FILE;
	shell_exec($ACTION);

	$ACTION = 'sudo -u root -S chown wwwrun '.$FILE;
	shell_exec($ACTION);

	// Open the text file
	$f = fopen($FILE, "w");

	// Write text
	fwrite($f, $VALUE); 

	// Close the text file
	fclose($f);

	$ACTION = 'sudo -u root -S chown root '.$FILE;
	shell_exec($ACTION);
}

function ServiceTitleField($LABEL){

	 ?><div class="form-group">
		<label class="col-xs-3 control-label"></label>
		<div class="col-xs-9">
			<h1><?php echo $LABEL; ?></h1>
		</div>
	</div> <?php
}

function ServiceEnabledField($ACTION, $NAME, $LABEL, $TYPE, $CHANGE, $HELP){

	$VALUE = exec($ACTION); ?>
	<div class="form-group">
		<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
		<div class="col-xs-4">
			<div class="<?php echo $TYPE; ?>">
				<label>
					<input type="<?php echo $TYPE; ?>" id="<?php echo $NAME; ?>_1" name="<?php echo $NAME; ?>" value="No" style="display: none;">
					<?php if ( $VALUE == "enabled" or $VALUE == "Yes") { ?>
						<input type="<?php echo $TYPE; ?>" id="enableservice" name="<?php echo $NAME; ?>" value="Yes" checked onchange="EnableDisableInput();" <?php echo $CHANGE; ?>>
					<?php } else { ?>
						<input type="<?php echo $TYPE; ?>" id="enableservice" name="<?php echo $NAME; ?>" value="Yes" onchange="EnableDisableInput();" <?php echo $CHANGE; ?>>
					<?php } ?>
				</label>
			</div>
		</div>
		<div class="col-xs-5">
			<span class="help-block">
				<p><?php echo $HELP; ?></p>
			</span>
		</div>
	</div> <?php
	return $VALUE;
}

function ServiceRunningField($ACTION, $SERVICE_ENABLED_VALUE, $NAME, $LABEL, $TYPE, $CHANGE, $HELP){

	exec($ACTION, $OUTPUT, $ERROR); ?>

	<?php if ($ERROR !== 0 and $LABEL == "Internet access") { ?>
		<div class="form-group has-error">
	<?php } elseif ($ERROR !== 0 and $SERVICE_ENABLED_VALUE == "enabled") { ?>
		<div class="form-group has-error">
	<?php } elseif ($ERROR !== 0 and $SERVICE_ENABLED_VALUE == "Yes") { ?>
		<div class="form-group has-error">
	<?php } elseif ($ERROR == 0){ ?>
		<div class="form-group has-success">
	<?php } else { ?>
		<div class="form-group">
	<?php } ?>
			<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
			<div class="col-xs-4">
				<div class="<?php echo $TYPE; ?>">
					<label>
						<?php if ($ERROR == 0) { ?>
							<input type="<?php echo $TYPE; ?>" name="<?php echo $NAME; ?>" value="Yes" checked <?php echo $CHANGE; ?>>
						<?php } else { ?>
							<input type="<?php echo $TYPE; ?>" name="<?php echo $NAME; ?>" value="Yes" <?php echo $CHANGE; ?>>
						<?php } ?>
					</label>
				</div>
			</div>
			<div class="col-xs-5">
				<span class="help-block">
					<p><?php echo $HELP; ?></p>
				</span>
			</div>
		</div> <?php
}

function ServiceStatusField($ACTION, $LABEL, $ROWS, $CHANGE){

	$OUTPUT = shell_exec($ACTION); ?>
	<div class="form-group">
		<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
		<div class="col-xs-9">
			<pre><?php echo $OUTPUT; ?></pre>
		</div>
	</div> <?php
}

function EditConfigFile($ACTION, $NAME, $LABEL, $ROWS, $CHANGE, $ID){

	$OUTPUT = shell_exec($ACTION); ?>

	<div class="form-group">
		<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
		<div class="col-xs-9">
			<textarea class="form-control" <?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" rows="<?php echo $ROWS; ?>"<?php echo $CHANGE; ?>><?php echo $OUTPUT; ?></textarea>
		</div>
	</div> <?php
}

function SysconfigInputField($ACTION, $NAME, $LABEL, $HELP, $TYPE, $CHANGE, $FILE, $ID){

	if (!empty($ACTION)) {
		$VALUE = exec($ACTION);
	} else {
		$VALUE = 'grep "^'.$NAME.'=" '.$FILE.' | awk -F"\'" \'{print $2}\'';
		$VALUE = exec($VALUE);
	} ?>

	<div class="form-group">
		<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
		<div class="col-xs-4">
			<?php if ($TYPE == "text") { ?>
				<input type="<?php echo $TYPE; ?>" class="form-control"<?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" value="<?php echo $VALUE; ?>" <?php echo $CHANGE; ?>>
			<?php } elseif ($TYPE == "checkbox") { ?>
				<div class="<?php echo $TYPE; ?>">
					<label>
						<input type="<?php echo $TYPE; ?>" id="<?php echo $NAME; ?>_1" name="<?php echo $NAME; ?>" value="No" style="display: none;">
						<?php if ( $VALUE == "Yes") { ?>
							<input type="<?php echo $TYPE; ?>" <?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" value="Yes" checked onchange="EnableDisableInput();" <?php echo $CHANGE; ?>>
						<?php } else { ?>
							<input type="<?php echo $TYPE; ?>" <?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" value="Yes" onchange="EnableDisableInput();" <?php echo $CHANGE; ?>>
						<?php } ?>
					</label>
				</div>
			<?php } ?>
		</div>
		<div class="col-xs-5">
			<span class="help-block">
				<?php echo $HELP; ?>
			</span>
		</div>
	</div> <?php
}

function SubmitButton($LABEL, $NAME, $HELP, $VALUE){

	?><div class="form-group">
		<label class="col-xs-3 control-label"></label>
		<div class="col-xs-4">
			<button type="submit" name="<?php echo $NAME; ?>" value="<?php echo $VALUE; ?>" class="btn btn-default btn-block"><?php echo $LABEL; ?></button>
		</div>
		<div class="col-xs-5">
			<span class="help-block">
				<?php echo $HELP; ?>
			</span>
		</div>
	</div> <?php
}

if (isset($_POST['reconfigure_button'])) {

	if (isset($_POST[$SERVICE_ENABLED_NAME])) ReconfigureAction($SERVICE_ENABLED_NAME, $_POST[$SERVICE_ENABLED_NAME], $ELMA_CONF);
	if (isset($_POST[$SYSCONFIG_1_NAME])) ReconfigureAction($SYSCONFIG_1_NAME, $_POST[$SYSCONFIG_1_NAME], $SYSCONFIG_1_FILE);
	if (isset($_POST[$SYSCONFIG_2_NAME])) ReconfigureAction($SYSCONFIG_2_NAME, $_POST[$SYSCONFIG_2_NAME], $SYSCONFIG_2_FILE);
	if (isset($_POST[$SYSCONFIG_3_NAME])) ReconfigureAction($SYSCONFIG_3_NAME, $_POST[$SYSCONFIG_3_NAME], $SYSCONFIG_3_FILE);
	if (isset($_POST[$SYSCONFIG_4_NAME])) ReconfigureAction($SYSCONFIG_4_NAME, $_POST[$SYSCONFIG_4_NAME], $SYSCONFIG_4_FILE);
	if (isset($_POST[$SYSCONFIG_5_NAME])) ReconfigureAction($SYSCONFIG_5_NAME, $_POST[$SYSCONFIG_5_NAME], $SYSCONFIG_5_FILE);
	if (isset($_POST[$SYSCONFIG_6_NAME])) ReconfigureAction($SYSCONFIG_6_NAME, $_POST[$SYSCONFIG_6_NAME], $SYSCONFIG_6_FILE);
	if (isset($_POST[$SYSCONFIG_7_NAME])) ReconfigureAction($SYSCONFIG_7_NAME, $_POST[$SYSCONFIG_7_NAME], $SYSCONFIG_7_FILE);
	if (isset($_POST[$SYSCONFIG_8_NAME])) ReconfigureAction($SYSCONFIG_8_NAME, $_POST[$SYSCONFIG_8_NAME], $SYSCONFIG_8_FILE);
	if (isset($_POST[$SYSCONFIG_9_NAME])) ReconfigureAction($SYSCONFIG_9_NAME, $_POST[$SYSCONFIG_9_NAME], $SYSCONFIG_9_FILE);
	if (isset($_POST[$SYSCONFIG_10_NAME])) ReconfigureAction($SYSCONFIG_10_NAME, $_POST[$SYSCONFIG_10_NAME], $SYSCONFIG_10_FILE);
	if (isset($_POST[$SYSCONFIG_11_NAME])) ReconfigureAction($SYSCONFIG_11_NAME, $_POST[$SYSCONFIG_11_NAME], $SYSCONFIG_11_FILE);
	if (isset($_POST[$SYSCONFIG_12_NAME])) ReconfigureAction($SYSCONFIG_12_NAME, $_POST[$SYSCONFIG_12_NAME], $SYSCONFIG_12_FILE);
	if (isset($_POST[$SYSCONFIG_13_NAME])) ReconfigureAction($SYSCONFIG_13_NAME, $_POST[$SYSCONFIG_13_NAME], $SYSCONFIG_13_FILE);
	if (isset($_POST[$SYSCONFIG_14_NAME])) ReconfigureAction($SYSCONFIG_14_NAME, $_POST[$SYSCONFIG_14_NAME], $SYSCONFIG_14_FILE);
	if (isset($_POST[$SYSCONFIG_15_NAME])) ReconfigureAction($SYSCONFIG_15_NAME, $_POST[$SYSCONFIG_15_NAME], $SYSCONFIG_15_FILE);
	if (isset($_POST[$SYSCONFIG_16_NAME])) ReconfigureAction($SYSCONFIG_16_NAME, $_POST[$SYSCONFIG_16_NAME], $SYSCONFIG_16_FILE);
	if (isset($_POST[$SYSCONFIG_17_NAME])) ReconfigureAction($SYSCONFIG_17_NAME, $_POST[$SYSCONFIG_17_NAME], $SYSCONFIG_17_FILE);
	if (isset($_POST[$SYSCONFIG_18_NAME])) ReconfigureAction($SYSCONFIG_18_NAME, $_POST[$SYSCONFIG_18_NAME], $SYSCONFIG_18_FILE);
	if (isset($_POST[$SYSCONFIG_19_NAME])) ReconfigureAction($SYSCONFIG_19_NAME, $_POST[$SYSCONFIG_19_NAME], $SYSCONFIG_19_FILE);

	if (isset($_POST[$SERVICE_EDIT_CONFIG_1_NAME])) EditConfigFileAction($_POST[$SERVICE_EDIT_CONFIG_1_NAME], $SERVICE_EDIT_CONFIG_1_FILE);
	if (isset($_POST[$SERVICE_EDIT_CONFIG_2_NAME])) EditConfigFileAction($_POST[$SERVICE_EDIT_CONFIG_2_NAME], $SERVICE_EDIT_CONFIG_2_FILE);
	if (isset($_POST[$SERVICE_EDIT_CONFIG_3_NAME])) EditConfigFileAction($_POST[$SERVICE_EDIT_CONFIG_3_NAME], $SERVICE_EDIT_CONFIG_3_FILE);
	if (isset($_POST[$SERVICE_EDIT_CONFIG_4_NAME])) EditConfigFileAction($_POST[$SERVICE_EDIT_CONFIG_4_NAME], $SERVICE_EDIT_CONFIG_4_FILE);
	if (isset($_POST[$SERVICE_EDIT_CONFIG_5_NAME])) EditConfigFileAction($_POST[$SERVICE_EDIT_CONFIG_5_NAME], $SERVICE_EDIT_CONFIG_5_FILE);

	list($ERROR, $SYSCONFIG_RECONFIGURE_ACTION) = ServiceAction($SYSCONFIG_RECONFIGURE_ACTION, $SYSCONFIG_RECONFIGURE_LABEL, ""); echo $ERROR;
} 

if (isset($_POST['service_config_1_button'])) {list($ERROR, $SERVICE_CONFIG_1_ACTION) = ServiceAction($SERVICE_CONFIG_1_ACTION, $SERVICE_CONFIG_1_LABEL, $SERVICE_CONFIG_1_FILE); echo $ERROR;}
if (isset($_POST['service_config_2_button'])) {list($ERROR, $SERVICE_CONFIG_2_ACTION) = ServiceAction($SERVICE_CONFIG_2_ACTION, $SERVICE_CONFIG_2_LABEL, $SERVICE_CONFIG_2_FILE); echo $ERROR;}
if (isset($_POST['service_config_3_button'])) {list($ERROR, $SERVICE_CONFIG_3_ACTION) = ServiceAction($SERVICE_CONFIG_3_ACTION, $SERVICE_CONFIG_3_LABEL, $SERVICE_CONFIG_3_FILE); echo $ERROR;}
if (isset($_POST['service_config_4_button'])) {list($ERROR, $SERVICE_CONFIG_4_ACTION) = ServiceAction($SERVICE_CONFIG_4_ACTION, $SERVICE_CONFIG_4_LABEL, $SERVICE_CONFIG_4_FILE); echo $ERROR;}
if (isset($_POST['service_config_5_button'])) {list($ERROR, $SERVICE_CONFIG_5_ACTION) = ServiceAction($SERVICE_CONFIG_5_ACTION, $SERVICE_CONFIG_5_LABEL, $SERVICE_CONFIG_5_FILE); echo $ERROR;}

if (isset($_POST['service_log_1_button'])) {list($ERROR, $SERVICE_LOG_1_ACTION) = ServiceAction($SERVICE_LOG_1_ACTION, $SERVICE_LOG_1_LABEL, $SERVICE_LOG_1_FILE); echo $ERROR;}
if (isset($_POST['service_log_2_button'])) {list($ERROR, $SERVICE_LOG_2_ACTION) = ServiceAction($SERVICE_LOG_2_ACTION, $SERVICE_LOG_2_LABEL, $SERVICE_LOG_2_FILE); echo $ERROR;}
if (isset($_POST['service_log_3_button'])) {list($ERROR, $SERVICE_LOG_3_ACTION) = ServiceAction($SERVICE_LOG_3_ACTION, $SERVICE_LOG_3_LABEL, $SERVICE_LOG_3_FILE); echo $ERROR;}
if (isset($_POST['service_log_4_button'])) {list($ERROR, $SERVICE_LOG_4_ACTION) = ServiceAction($SERVICE_LOG_4_ACTION, $SERVICE_LOG_4_LABEL, $SERVICE_LOG_4_FILE); echo $ERROR;}
if (isset($_POST['service_log_5_button'])) {list($ERROR, $SERVICE_LOG_5_ACTION) = ServiceAction($SERVICE_LOG_5_ACTION, $SERVICE_LOG_5_LABEL, $SERVICE_LOG_5_FILE); echo $ERROR;}

?>

<form onsubmit="submitted();" method="post" accept-charset="UTF-8" class="form-horizontal" role="form">

	<?php

	/*
	 * Form elements
	 */

	if (!empty($SERVICE_TITEL_LABEL)) ServiceTitleField($SERVICE_TITEL_LABEL);

	if (!empty($SERVICE_ENABLED_LABEL)) $SERVICE_ENABLED_VALUE = ServiceEnabledField($SERVICE_ENABLED_ACTION, $SERVICE_ENABLED_NAME, $SERVICE_ENABLED_LABEL, $SERVICE_ENABLED_TYPE, $SERVICE_ENABLED_CHANGE, $SERVICE_ENABLED_HELP);
	if (!empty($SERVICE_RUNNING_LABEL)) ServiceRunningField($SERVICE_RUNNING_ACTION, $SERVICE_ENABLED_VALUE, $SERVICE_RUNNING_NAME, $SERVICE_RUNNING_LABEL, $SERVICE_RUNNING_TYPE, $SERVICE_RUNNING_CHANGE, $SERVICE_RUNNING_HELP);

	if (!empty($SERVICE_STATUS_1_LABEL)) ServiceStatusField($SERVICE_STATUS_1_ACTION, $SERVICE_STATUS_1_LABEL, $SERVICE_STATUS_1_ROWS, $SERVICE_STATUS_1_CHANGE);
	if (!empty($SERVICE_STATUS_2_LABEL)) ServiceStatusField($SERVICE_STATUS_2_ACTION, $SERVICE_STATUS_2_LABEL, $SERVICE_STATUS_2_ROWS, $SERVICE_STATUS_2_CHANGE);
	if (!empty($SERVICE_STATUS_3_LABEL)) ServiceStatusField($SERVICE_STATUS_3_ACTION, $SERVICE_STATUS_3_LABEL, $SERVICE_STATUS_3_ROWS, $SERVICE_STATUS_3_CHANGE);
	if (!empty($SERVICE_STATUS_4_LABEL)) ServiceStatusField($SERVICE_STATUS_4_ACTION, $SERVICE_STATUS_4_LABEL, $SERVICE_STATUS_4_ROWS, $SERVICE_STATUS_4_CHANGE);
	if (!empty($SERVICE_STATUS_5_LABEL)) ServiceStatusField($SERVICE_STATUS_5_ACTION, $SERVICE_STATUS_5_LABEL, $SERVICE_STATUS_5_ROWS, $SERVICE_STATUS_5_CHANGE);

	if (!empty($SYSCONFIG_1_LABEL)) SysconfigInputField($SYSCONFIG_1_ACTION, $SYSCONFIG_1_NAME, $SYSCONFIG_1_LABEL, $SYSCONFIG_1_HELP, $SYSCONFIG_1_TYPE, $SYSCONFIG_1_CHANGE, $SYSCONFIG_1_FILE, "sysconfig1");
	if (!empty($SYSCONFIG_2_LABEL)) SysconfigInputField($SYSCONFIG_2_ACTION, $SYSCONFIG_2_NAME, $SYSCONFIG_2_LABEL, $SYSCONFIG_2_HELP, $SYSCONFIG_2_TYPE, $SYSCONFIG_2_CHANGE, $SYSCONFIG_2_FILE, "sysconfig2");
	if (!empty($SYSCONFIG_3_LABEL)) SysconfigInputField($SYSCONFIG_3_ACTION, $SYSCONFIG_3_NAME, $SYSCONFIG_3_LABEL, $SYSCONFIG_3_HELP, $SYSCONFIG_3_TYPE, $SYSCONFIG_3_CHANGE, $SYSCONFIG_3_FILE, "sysconfig3");
	if (!empty($SYSCONFIG_4_LABEL)) SysconfigInputField($SYSCONFIG_4_ACTION, $SYSCONFIG_4_NAME, $SYSCONFIG_4_LABEL, $SYSCONFIG_4_HELP, $SYSCONFIG_4_TYPE, $SYSCONFIG_4_CHANGE, $SYSCONFIG_4_FILE, "sysconfig4");
	if (!empty($SYSCONFIG_5_LABEL)) SysconfigInputField($SYSCONFIG_5_ACTION, $SYSCONFIG_5_NAME, $SYSCONFIG_5_LABEL, $SYSCONFIG_5_HELP, $SYSCONFIG_5_TYPE, $SYSCONFIG_5_CHANGE, $SYSCONFIG_5_FILE, "sysconfig5");
	if (!empty($SYSCONFIG_6_LABEL)) SysconfigInputField($SYSCONFIG_6_ACTION, $SYSCONFIG_6_NAME, $SYSCONFIG_6_LABEL, $SYSCONFIG_6_HELP, $SYSCONFIG_6_TYPE, $SYSCONFIG_6_CHANGE, $SYSCONFIG_6_FILE, "sysconfig6");
	if (!empty($SYSCONFIG_7_LABEL)) SysconfigInputField($SYSCONFIG_7_ACTION, $SYSCONFIG_7_NAME, $SYSCONFIG_7_LABEL, $SYSCONFIG_7_HELP, $SYSCONFIG_7_TYPE, $SYSCONFIG_7_CHANGE, $SYSCONFIG_7_FILE, "sysconfig7");
	if (!empty($SYSCONFIG_8_LABEL)) SysconfigInputField($SYSCONFIG_8_ACTION, $SYSCONFIG_8_NAME, $SYSCONFIG_8_LABEL, $SYSCONFIG_8_HELP, $SYSCONFIG_8_TYPE, $SYSCONFIG_8_CHANGE, $SYSCONFIG_8_FILE, "sysconfig8");
	if (!empty($SYSCONFIG_9_LABEL)) SysconfigInputField($SYSCONFIG_9_ACTION, $SYSCONFIG_9_NAME, $SYSCONFIG_9_LABEL, $SYSCONFIG_9_HELP, $SYSCONFIG_9_TYPE, $SYSCONFIG_9_CHANGE, $SYSCONFIG_9_FILE, "sysconfig9");
	if (!empty($SYSCONFIG_10_LABEL)) SysconfigInputField($SYSCONFIG_10_ACTION, $SYSCONFIG_10_NAME, $SYSCONFIG_10_LABEL, $SYSCONFIG_10_HELP, $SYSCONFIG_10_TYPE, $SYSCONFIG_10_CHANGE, $SYSCONFIG_10_FILE, "sysconfig10");
	if (!empty($SYSCONFIG_11_LABEL)) SysconfigInputField($SYSCONFIG_11_ACTION, $SYSCONFIG_11_NAME, $SYSCONFIG_11_LABEL, $SYSCONFIG_11_HELP, $SYSCONFIG_11_TYPE, $SYSCONFIG_11_CHANGE, $SYSCONFIG_11_FILE, "sysconfig11");
	if (!empty($SYSCONFIG_12_LABEL)) SysconfigInputField($SYSCONFIG_12_ACTION, $SYSCONFIG_12_NAME, $SYSCONFIG_12_LABEL, $SYSCONFIG_12_HELP, $SYSCONFIG_12_TYPE, $SYSCONFIG_12_CHANGE, $SYSCONFIG_12_FILE, "sysconfig12");
	if (!empty($SYSCONFIG_13_LABEL)) SysconfigInputField($SYSCONFIG_13_ACTION, $SYSCONFIG_13_NAME, $SYSCONFIG_13_LABEL, $SYSCONFIG_13_HELP, $SYSCONFIG_13_TYPE, $SYSCONFIG_13_CHANGE, $SYSCONFIG_13_FILE, "sysconfig13");
	if (!empty($SYSCONFIG_14_LABEL)) SysconfigInputField($SYSCONFIG_14_ACTION, $SYSCONFIG_14_NAME, $SYSCONFIG_14_LABEL, $SYSCONFIG_14_HELP, $SYSCONFIG_14_TYPE, $SYSCONFIG_14_CHANGE, $SYSCONFIG_14_FILE, "sysconfig14");
	if (!empty($SYSCONFIG_15_LABEL)) SysconfigInputField($SYSCONFIG_15_ACTION, $SYSCONFIG_15_NAME, $SYSCONFIG_15_LABEL, $SYSCONFIG_15_HELP, $SYSCONFIG_15_TYPE, $SYSCONFIG_15_CHANGE, $SYSCONFIG_15_FILE, "sysconfig15");
	if (!empty($SYSCONFIG_16_LABEL)) SysconfigInputField($SYSCONFIG_16_ACTION, $SYSCONFIG_16_NAME, $SYSCONFIG_16_LABEL, $SYSCONFIG_16_HELP, $SYSCONFIG_16_TYPE, $SYSCONFIG_16_CHANGE, $SYSCONFIG_16_FILE, "sysconfig16");
	if (!empty($SYSCONFIG_17_LABEL)) SysconfigInputField($SYSCONFIG_17_ACTION, $SYSCONFIG_17_NAME, $SYSCONFIG_17_LABEL, $SYSCONFIG_17_HELP, $SYSCONFIG_17_TYPE, $SYSCONFIG_17_CHANGE, $SYSCONFIG_17_FILE, "sysconfig17");
	if (!empty($SYSCONFIG_18_LABEL)) SysconfigInputField($SYSCONFIG_18_ACTION, $SYSCONFIG_18_NAME, $SYSCONFIG_18_LABEL, $SYSCONFIG_18_HELP, $SYSCONFIG_18_TYPE, $SYSCONFIG_18_CHANGE, $SYSCONFIG_18_FILE, "sysconfig18");
	if (!empty($SYSCONFIG_19_LABEL)) SysconfigInputField($SYSCONFIG_19_ACTION, $SYSCONFIG_19_NAME, $SYSCONFIG_19_LABEL, $SYSCONFIG_19_HELP, $SYSCONFIG_19_TYPE, $SYSCONFIG_19_CHANGE, $SYSCONFIG_19_FILE, "sysconfig19");

	if (!empty($SERVICE_EDIT_CONFIG_1_LABEL)) EditConfigFile($SERVICE_EDIT_CONFIG_1_ACTION, $SERVICE_EDIT_CONFIG_1_NAME, $SERVICE_EDIT_CONFIG_1_LABEL, $SERVICE_EDIT_CONFIG_1_ROWS, $SERVICE_EDIT_CONFIG_1_CHANGE, "editsysconfig1");
	if (!empty($SERVICE_EDIT_CONFIG_2_LABEL)) EditConfigFile($SERVICE_EDIT_CONFIG_2_ACTION, $SERVICE_EDIT_CONFIG_2_NAME, $SERVICE_EDIT_CONFIG_2_LABEL, $SERVICE_EDIT_CONFIG_2_ROWS, $SERVICE_EDIT_CONFIG_2_CHANGE, "editsysconfig2");
	if (!empty($SERVICE_EDIT_CONFIG_3_LABEL)) EditConfigFile($SERVICE_EDIT_CONFIG_3_ACTION, $SERVICE_EDIT_CONFIG_3_NAME, $SERVICE_EDIT_CONFIG_3_LABEL, $SERVICE_EDIT_CONFIG_3_ROWS, $SERVICE_EDIT_CONFIG_3_CHANGE, "editsysconfig3");
	if (!empty($SERVICE_EDIT_CONFIG_4_LABEL)) EditConfigFile($SERVICE_EDIT_CONFIG_4_ACTION, $SERVICE_EDIT_CONFIG_4_NAME, $SERVICE_EDIT_CONFIG_4_LABEL, $SERVICE_EDIT_CONFIG_4_ROWS, $SERVICE_EDIT_CONFIG_4_CHANGE, "editsysconfig4");
	if (!empty($SERVICE_EDIT_CONFIG_5_LABEL)) EditConfigFile($SERVICE_EDIT_CONFIG_5_ACTION, $SERVICE_EDIT_CONFIG_5_NAME, $SERVICE_EDIT_CONFIG_5_LABEL, $SERVICE_EDIT_CONFIG_5_ROWS, $SERVICE_EDIT_CONFIG_5_CHANGE, "editsysconfig5");

	if (!empty($SYSCONFIG_RECONFIGURE_LABEL)) SubmitButton("Save and reconfigure service", "reconfigure_button", $SYSCONFIG_RECONFIGURE_HELP, "Save");

	if (!empty($SERVICE_CONFIG_1_LABEL)) SubmitButton($SERVICE_CONFIG_1_LABEL, "service_config_1_button", $SERVICE_CONFIG_1_HELP, "Log");
	if (!empty($SERVICE_CONFIG_2_LABEL)) SubmitButton($SERVICE_CONFIG_2_LABEL, "service_config_2_button", $SERVICE_CONFIG_2_HELP, "Log");
	if (!empty($SERVICE_CONFIG_3_LABEL)) SubmitButton($SERVICE_CONFIG_3_LABEL, "service_config_3_button", $SERVICE_CONFIG_3_HELP, "Log");
	if (!empty($SERVICE_CONFIG_4_LABEL)) SubmitButton($SERVICE_CONFIG_4_LABEL, "service_config_4_button", $SERVICE_CONFIG_4_HELP, "Log");
	if (!empty($SERVICE_CONFIG_5_LABEL)) SubmitButton($SERVICE_CONFIG_5_LABEL, "service_config_5_button", $SERVICE_CONFIG_5_HELP, "Log");

	if (!empty($SERVICE_LOG_1_LABEL)) SubmitButton($SERVICE_LOG_1_LABEL, "service_log_1_button", $SERVICE_LOG_1_HELP, "Log");
	if (!empty($SERVICE_LOG_2_LABEL)) SubmitButton($SERVICE_LOG_2_LABEL, "service_log_2_button", $SERVICE_LOG_2_HELP, "Log");
	if (!empty($SERVICE_LOG_3_LABEL)) SubmitButton($SERVICE_LOG_3_LABEL, "service_log_3_button", $SERVICE_LOG_3_HELP, "Log");
	if (!empty($SERVICE_LOG_4_LABEL)) SubmitButton($SERVICE_LOG_4_LABEL, "service_log_4_button", $SERVICE_LOG_4_HELP, "Log");
	if (!empty($SERVICE_LOG_5_LABEL)) SubmitButton($SERVICE_LOG_5_LABEL, "service_log_5_button", $SERVICE_LOG_5_HELP, "Log");
	?>

</form>

<script>
	//call after page loaded
	window.onload=EnableDisableInput(); 
</script>

<?php

/*
 * Action outputs
 */

if (isset($_POST['reconfigure_button'])) echo $SYSCONFIG_RECONFIGURE_ACTION;

if (isset($_POST['service_config_1_button'])) echo $SERVICE_CONFIG_1_ACTION;
if (isset($_POST['service_config_2_button'])) echo $SERVICE_CONFIG_2_ACTION;
if (isset($_POST['service_config_3_button'])) echo $SERVICE_CONFIG_3_ACTION;
if (isset($_POST['service_config_4_button'])) echo $SERVICE_CONFIG_4_ACTION;
if (isset($_POST['service_config_5_button'])) echo $SERVICE_CONFIG_5_ACTION;

if (isset($_POST['service_log_1_button'])) echo $SERVICE_LOG_1_ACTION;
if (isset($_POST['service_log_2_button'])) echo $SERVICE_LOG_2_ACTION;
if (isset($_POST['service_log_3_button'])) echo $SERVICE_LOG_3_ACTION;
if (isset($_POST['service_log_4_button'])) echo $SERVICE_LOG_4_ACTION;
if (isset($_POST['service_log_5_button'])) echo $SERVICE_LOG_5_ACTION;
?>
