<?php

/*
 * ELMA SNMP setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/ftp.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "FTP setup";

$SERVICE_SYSTEMD_NAME = "vsftpd.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --ftp';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "FTP_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable FTP daemon (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "FTP_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of FTP deamon (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/vsftpd.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "ftpusers";
$SERVICE_CONFIG_2_FILE = "/etc/ftpusers";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

include("form.inc");

?>
