<?php

/*
 * ELMA Mail setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/mail.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Mail setup";

$SERVICE_SYSTEMD_NAME = "postfix.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --postfix';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "POSTFIX_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable Postfix Mail Transport Agent (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "POSTFIX_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Postfix Mail Transport Agent (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Mail aliases";
$SERVICE_CONFIG_1_FILE = "/etc/aliases";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Send testmail";
$SERVICE_LOG_2_HELP = "";
$SERVICE_LOG_2_FILE = "";
$SERVICE_LOG_2_ACTION = 'echo "Testmail to user root from $(hostname -f)"; echo "Testmail to user root from $(hostname -f)" | mail -s"Testmail from $(hostname -f)" root';

$SYSCONFIG_1_LABEL = "MAIL_RELAYHOST";
$SYSCONFIG_1_NAME = "MAIL_RELAYHOST";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>SMTP mailrelay host of the postfix MTA (used by local postfix service)</p><ol style="list-style-type:disc";><li>IP addresses or FQDNs from your smtp mailrelay servers seperated with a blank</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_2_LABEL = "MAIL_REDIRECT";
$SYSCONFIG_2_NAME = "MAIL_REDIRECT";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>Redirect all email to "root" to the address of a HUMAN who deals with this system\'s problems</p><ol style="list-style-type:disc";><li>Email addresses for system mail redirection seperated with a blank</li><li>Default value: leave it to blank</li></ol>';

include("form.inc");

?>
