<?php

/*
 * ELMA Nagios setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/nagios.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Nagios setup";

$SERVICE_SYSTEMD_NAME = "nagios.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --nagios';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "NAGIOS_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable Network monitor Nagios (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "NAGIOS_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Network monitor Nagios (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "Nagios log";
$SERVICE_LOG_2_FILE = "/var/log/nagios/nagios.log";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SYSCONFIG_1_LABEL = "NAGIOS_ADMIN_UID";
$SYSCONFIG_1_NAME = "NAGIOS_ADMIN_UID";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "disabled";
$SYSCONFIG_1_HELP = '<p>Default Nagios admin UIDs for system/process command access</p><ol style="list-style-type:disc";><li>This option is a comma-delimited list of all usernames that can issue shutdown and restart commands to Nagios via the command CGI (cmd.cgi). Users in this list can also change the program mode to active or standby. By default, *no one* has access to this unless you choose to not use authorization. You may use an asterisk (*) to authorize any user who has authenticated to the web server.</li></ol>';

$SYSCONFIG_2_LABEL = "NAGIOS_ADMIN_EMAIL";
$SYSCONFIG_2_NAME = "NAGIOS_ADMIN_EMAIL";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>Email address of a global administrator (likely you)</p><ol style="list-style-type:disc";><li>Example: admin@example.com</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_3_LABEL = "NAGIOS_ADMIN_PAGER";
$SYSCONFIG_3_NAME = "NAGIOS_ADMIN_PAGER";
$SYSCONFIG_3_TYPE = "text";
$SYSCONFIG_3_CHANGE = "enabled";
$SYSCONFIG_3_HELP = '<p>Pager address of a global administrator (likely you)</p><ol style="list-style-type:disc";><li>Example: admin@example.com</li><li>Default value: leave it to blank</li></ol>';

include("form.inc");

?>