<?php

/*
 * ELMA NTP setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/network.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Network setup";

$SERVICE_SYSTEMD_NAME = "network.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --network';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "NETWORK_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable Network manager (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "NETWORK_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Network manager (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_2_LABEL = "Internet access";
$SERVICE_STATUS_2_TYPE = "textarea";
$SERVICE_STATUS_2_ROWS = "3";
$SERVICE_STATUS_2_CHANGE = "disabled";
$SERVICE_STATUS_2_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --internet';

$SERVICE_STATUS_3_LABEL = "DNS resolving";
$SERVICE_STATUS_3_TYPE = "textarea";
$SERVICE_STATUS_3_ROWS = "6";
$SERVICE_STATUS_3_CHANGE = "disabled";
$SERVICE_STATUS_3_ACTION = "hostname -f | nslookup";

$SERVICE_STATUS_4_LABEL = "Time synchronization";
$SERVICE_STATUS_4_TYPE = "textarea";
$SERVICE_STATUS_4_ROWS = "3";
$SERVICE_STATUS_4_CHANGE = "disabled";
$SERVICE_STATUS_4_ACTION = "/usr/sbin/ntpdc -p";

$SERVICE_STATUS_5_LABEL = "Systemtime";
$SERVICE_STATUS_5_TYPE = "textarea";
$SERVICE_STATUS_5_ROWS = "6";
$SERVICE_STATUS_5_CHANGE = "disabled";
$SERVICE_STATUS_5_ACTION = "/usr/bin/timedatectl status";

$SERVICE_STATUS_6_LABEL = "Hardwaretime";
$SERVICE_STATUS_6_TYPE = "textarea";
$SERVICE_STATUS_6_ROWS = "3";
$SERVICE_STATUS_6_CHANGE = "disabled";
$SERVICE_STATUS_6_ACTION = "/sbin/hwclock --show";

$SERVICE_CONFIG_1_LABEL = "Network sysconfig";
$SERVICE_CONFIG_1_FILE = "/etc/sysconfig/network/config";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "DNS network sysconfig";
$SERVICE_CONFIG_2_FILE = "/etc/resolv.conf";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_CONFIG_3_LABEL = "Hostname-to-Address mappings";
$SERVICE_CONFIG_3_FILE = "/etc/hosts";
$SERVICE_CONFIG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_3_FILE;
$SERVICE_CONFIG_3_HELP = $SERVICE_CONFIG_3_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SYSCONFIG_1_LABEL = "DNS_SERVER";
$SYSCONFIG_1_NAME = "NETCONFIG_DNS_STATIC_SERVERS";
$SYSCONFIG_1_FILE = $NET_CONF;
$SYSCONFIG_1_ACTION = 'grep "^'.$SYSCONFIG_1_NAME.'=" '.$SYSCONFIG_1_FILE.' | awk -F"\"" \'{print $2}\'';
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>DNS server reachable over the network (used by local resolving clients)</p><ol style="list-style-type:disc";><li>IP addresses from your DNS servers seperated with a blank</li><li>To use local bind service: 127.0.0.1</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_2_LABEL = "DNS_SEARCHLIST";
$SYSCONFIG_2_NAME = "NETCONFIG_DNS_STATIC_SEARCHLIST";
$SYSCONFIG_2_FILE = $NET_CONF;
$SYSCONFIG_2_ACTION = 'grep "^'.$SYSCONFIG_2_NAME.'=" '.$SYSCONFIG_2_FILE.' | awk -F"\"" \'{print $2}\'';
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>List of DNS domain names used for host-name lookup seperated with a blank</p><ol style="list-style-type:disc";><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_3_LABEL = "NTP_SERVER";
$SYSCONFIG_3_NAME = "NETCONFIG_NTP_STATIC_SERVERS";
$SYSCONFIG_3_FILE = $NET_CONF;
$SYSCONFIG_3_ACTION = 'grep "^'.$SYSCONFIG_3_NAME.'=" '.$SYSCONFIG_3_FILE.' | awk -F"\"" \'{print $2}\'';
$SYSCONFIG_3_TYPE = "text";
$SYSCONFIG_3_CHANGE = "enabled";
$SYSCONFIG_3_HELP = '<p>NTP / Time server reachable over the network (used by local time clients)</p><ol style="list-style-type:disc";><li>IP addresses or FQDNs from your time servers seperated with a blank</li><li>Default openSUSE values: 0.opensuse.pool.ntp.org 1.opensuse.pool.ntp.org 2.opensuse.pool.ntp.org 3.opensuse.pool.ntp.org</li><li>To use local ntpd service: 127.0.0.1</li><li>Default value: leave it to blank</li></ol>';

include("form.inc");

?>
