<?php

/*
 * ELMA NTP setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/ntp.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "NTP setup";

$SERVICE_SYSTEMD_NAME = "ntp.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --ntp';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "NTP_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable Network time protocol daemon (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "NTP_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of Network time protocol daemon (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_2_LABEL = "Time synchronization";
$SERVICE_STATUS_2_TYPE = "textarea";
$SERVICE_STATUS_2_ROWS = "3";
$SERVICE_STATUS_2_CHANGE = "disabled";
$SERVICE_STATUS_2_ACTION = "/usr/sbin/ntpdc -p";

$SERVICE_STATUS_3_LABEL = "Systemtime";
$SERVICE_STATUS_3_TYPE = "textarea";
$SERVICE_STATUS_3_ROWS = "6";
$SERVICE_STATUS_3_CHANGE = "disabled";
$SERVICE_STATUS_3_ACTION = "/usr/bin/timedatectl status";

$SERVICE_STATUS_4_LABEL = "Hardwaretime";
$SERVICE_STATUS_4_TYPE = "textarea";
$SERVICE_STATUS_4_ROWS = "3";
$SERVICE_STATUS_4_CHANGE = "disabled";
$SERVICE_STATUS_4_ACTION = "/sbin/hwclock --show";

$SERVICE_CONFIG_1_LABEL = "Configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/ntp.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "NTP log";
$SERVICE_LOG_2_FILE = "/var/log/ntp";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SYSCONFIG_1_LABEL = "NTP_FORWARDER";
$SYSCONFIG_1_NAME = "NTP_FORWARDER";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>NTP forwarder server</p><ol style="list-style-type:disc";><li>IP addresses or FQDNs from your time servers seperated with a blank</li><li>Default openSUSE values: 0.opensuse.pool.ntp.org 1.opensuse.pool.ntp.org 2.opensuse.pool.ntp.org 3.opensuse.pool.ntp.org</li><li>Default value: leave it to blank</li></ol>';

include("form.inc");

?>
