<?php

/*
 * ELMA Proxy setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/proxy.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "Proxy setup";

$SERVICE_SYSTEMD_NAME = "proxy.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --proxy';

$SERVICE_ENABLED_LABEL = "Enable usage";
$SERVICE_ENABLED_NAME = "PROXY_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable proxy usage for internet access";
$SERVICE_ENABLED_ACTION = 'grep "^'.$SERVICE_ENABLED_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SERVICE_RUNNING_LABEL = "Internet access";
$SERVICE_RUNNING_NAME = "PROXY_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of internet reachability";
$SERVICE_RUNNING_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --internet';

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "3";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --internet';

$SERVICE_CONFIG_1_LABEL = "Proxy sysconfig";
$SERVICE_CONFIG_1_FILE = "/etc/sysconfig/proxy";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SYSCONFIG_1_LABEL = "PROXY_PROTOCOL";
$SYSCONFIG_1_NAME = "PROXY_PROTOCOL";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>Proxy protocol</p><ol style="list-style-type:disc";><li>Protocol can be "http" or "https"</li><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_2_LABEL = "PROXY_HOST";
$SYSCONFIG_2_NAME = "PROXY_HOST";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "enabled";
$SYSCONFIG_2_HELP = '<p>Full qualified domain name or IP from your proxy host</p><ol style="list-style-type:disc";><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_3_LABEL = "PROXY_PORT";
$SYSCONFIG_3_NAME = "PROXY_PORT";
$SYSCONFIG_3_TYPE = "text";
$SYSCONFIG_3_CHANGE = "enabled";
$SYSCONFIG_3_HELP = '<p>Proxy port</p><ol style="list-style-type:disc";><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_4_LABEL = "PROXY_AUTH_ENABLED";
$SYSCONFIG_4_NAME = "PROXY_AUTH_ENABLED";
$SYSCONFIG_4_TYPE = "checkbox";
$SYSCONFIG_4_CHANGE = "enabled";
$SYSCONFIG_4_HELP = '<p>Enable basic proxy authentication</p>';
$SYSCONFIG_4_ACTION = 'grep "^'.$SYSCONFIG_4_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_5_LABEL = "PROXY_UID";
$SYSCONFIG_5_NAME = "PROXY_UID";
$SYSCONFIG_5_TYPE = "text";
$SYSCONFIG_5_CHANGE = "enabled";
$SYSCONFIG_5_HELP = '<p>Proxy UID</p><ol style="list-style-type:disc";><li>Default value: leave it to blank</li></ol>';

$SYSCONFIG_6_LABEL = "PROXY_PWD";
$SYSCONFIG_6_NAME = "PROXY_PWD";
$SYSCONFIG_6_TYPE = "text";
$SYSCONFIG_6_CHANGE = "enabled";
$SYSCONFIG_6_HELP = '<p>Proxy password</p><ol style="list-style-type:disc";><li>Default value: leave it to blank</li></ol>';

include("form.inc");

?>
