<?php

/*
 * ELMA rsyslog setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/rsyslog-mail-alert.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "rsyslog mail alerting setup";

$SERVICE_SYSTEMD_NAME = "rsyslog.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --rsyslog';

$SERVICE_ENABLED_LABEL = "Include configuration file";
$SERVICE_ENABLED_NAME = "RSYSLOG_MAIL_ALERTING_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Alert specific events via mail";
$SERVICE_ENABLED_ACTION = 'grep "^'.$SERVICE_ENABLED_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "RSYSLOG_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of System Logging Service (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Include configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/rsyslog.d/remote.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "Default ruleset";
$SERVICE_CONFIG_2_FILE = "/etc/rsyslog.d/elma_output-mail-action-template.conf.org";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_EDIT_CONFIG_2_LABEL = "Ruleset";
$SERVICE_EDIT_CONFIG_2_NAME = "RSYSLOG_MAIL_RULESET";
$SERVICE_EDIT_CONFIG_2_TYPE = "textarea";
$SERVICE_EDIT_CONFIG_2_ROWS = "16";
$SERVICE_EDIT_CONFIG_2_CHANGE = "enabled";
$SERVICE_EDIT_CONFIG_2_FILE = "/etc/rsyslog.d/elma_output-mail-action-template.conf";
$SERVICE_EDIT_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_EDIT_CONFIG_2_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

include("form.inc");

?>
