<?php

/*
 * ELMA rsyslog setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/rsyslog.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "rsyslog setup";

$SERVICE_SYSTEMD_NAME = "rsyslog.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --rsyslog';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "RSYSLOG_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "disabled";
$SERVICE_ENABLED_HELP = "Enable System Logging Service (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "RSYSLOG_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of System Logging Service (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/rsyslog.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_CONFIG_2_LABEL = "Include configuration file";
$SERVICE_CONFIG_2_FILE = "/etc/rsyslog.d/remote.conf";
$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SYSCONFIG_1_LABEL = "Reduce dupplicate";
$SYSCONFIG_1_NAME = "RSYSLOG_REDUCE_DUPPLICATE_ENABLED";
$SYSCONFIG_1_TYPE = "checkbox";
$SYSCONFIG_1_CHANGE = "enabled";
$SYSCONFIG_1_HELP = '<p>Reduce dupplicate events (last message repeated n times)</p>';
$SYSCONFIG_1_ACTION = 'grep "^'.$SYSCONFIG_1_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_2_LABEL = "Main queue";
$SYSCONFIG_2_NAME = "RSYSLOG_MAIN_QUEUE_ENABLED";
$SYSCONFIG_2_TYPE = "checkbox";
$SYSCONFIG_2_CHANGE = "disabled";
$SYSCONFIG_2_HELP = '<p>In memory main queue with dynamic RAM allocation</p>';
$SYSCONFIG_2_ACTION = 'grep "^'.$SYSCONFIG_2_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_3_LABEL = "Drop filter";
$SYSCONFIG_3_NAME = "RSYSLOG_DROP_FILTER_ENABLED";
$SYSCONFIG_3_TYPE = "checkbox";
$SYSCONFIG_3_CHANGE = "disabled";
$SYSCONFIG_3_HELP = '<p>Drop unwanted events by filter rules</p>';
$SYSCONFIG_3_ACTION = 'grep "^'.$SYSCONFIG_3_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_4_LABEL = "liblognorm normalization";
$SYSCONFIG_4_NAME = "RSYSLOG_LIBLOGNORM_NORMALIZATION_ENABLED";
$SYSCONFIG_4_TYPE = "checkbox";
$SYSCONFIG_4_CHANGE = "disabled";
$SYSCONFIG_4_HELP = '<p>Event normalization via liblognorm</p>';
$SYSCONFIG_4_ACTION = 'grep "^'.$SYSCONFIG_4_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_5_LABEL = "CEE normalization";
$SYSCONFIG_5_NAME = "RSYSLOG_CEE_NORMALIZATION_ENABLED";
$SYSCONFIG_5_TYPE = "checkbox";
$SYSCONFIG_5_CHANGE = "disabled";
$SYSCONFIG_5_HELP = '<p>Event normalization via CEE cookies</p>';
$SYSCONFIG_5_ACTION = 'grep "^'.$SYSCONFIG_5_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_6_LABEL = "JSON format";
$SYSCONFIG_6_NAME = "RSYSLOG_JSON_FORMAT_ENABLED";
$SYSCONFIG_6_TYPE = "checkbox";
$SYSCONFIG_6_CHANGE = "disabled";
$SYSCONFIG_6_HELP = '<p>JSON output format</p>';
$SYSCONFIG_6_ACTION = 'grep "^'.$SYSCONFIG_6_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_7_LABEL = "Forwarding to ElasticSearch";
$SYSCONFIG_7_NAME = "RSYSLOG_FORWARDING_ES_ENABLED";
$SYSCONFIG_7_TYPE = "checkbox";
$SYSCONFIG_7_CHANGE = "disabled";
$SYSCONFIG_7_HELP = '<p>Event forwarding to ElasticSearch</p>';
$SYSCONFIG_7_ACTION = 'grep "^'.$SYSCONFIG_7_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_8_LABEL = "Local logfile";
$SYSCONFIG_8_NAME = "RSYSLOG_LOCAL_LOGFILE_ENABLED";
$SYSCONFIG_8_TYPE = "checkbox";
$SYSCONFIG_8_CHANGE = "disabled";
$SYSCONFIG_8_HELP = '<p>Log everything to a per host daily logfile</p>';
$SYSCONFIG_8_ACTION = 'grep "^'.$SYSCONFIG_8_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_9_LABEL = "Forwarding to remote syslog";
$SYSCONFIG_9_NAME = "RSYSLOG_FORWARDING_REMOTE_SYSLOG_ENABLED";
$SYSCONFIG_9_TYPE = "checkbox";
$SYSCONFIG_9_CHANGE = "disabled";
$SYSCONFIG_9_HELP = '<p>Event forwarding to remote syslog</p>';
$SYSCONFIG_9_ACTION = 'grep "^'.$SYSCONFIG_9_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_11_LABEL = "TLS forwarding to remote rsyslog";
$SYSCONFIG_11_NAME = "RSYSLOG_FORWARDING_REMOTE_TLS_RSYSLOG_ENABLED";
$SYSCONFIG_11_TYPE = "checkbox";
$SYSCONFIG_11_CHANGE = "disabled";
$SYSCONFIG_11_HELP = '<p>TLS encrypted event forwarding to remote rsyslog</p>';
$SYSCONFIG_11_ACTION = 'grep "^'.$SYSCONFIG_11_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_12_LABEL = "Customized action template";
$SYSCONFIG_12_NAME = "RSYSLOG_CUSTOMIZE_ACTION_TEMPLATE_ENABLED";
$SYSCONFIG_12_TYPE = "checkbox";
$SYSCONFIG_12_CHANGE = "disabled";
$SYSCONFIG_12_HELP = '<p>Config template for customized output action rules</p>';
$SYSCONFIG_12_ACTION = 'grep "^'.$SYSCONFIG_12_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_13_LABEL = "Mail alerting";
$SYSCONFIG_13_NAME = "RSYSLOG_MAIL_ALERTING_ENABLED";
$SYSCONFIG_13_TYPE = "checkbox";
$SYSCONFIG_13_CHANGE = "disabled";
$SYSCONFIG_13_HELP = '<p>Alert specific events via mail</p>';
$SYSCONFIG_13_ACTION = 'grep "^'.$SYSCONFIG_13_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_14_LABEL = "Forwarding to local syslog";
$SYSCONFIG_14_NAME = "RSYSLOG_LOCAL_SYSLOG_ENABLED";
$SYSCONFIG_14_TYPE = "checkbox";
$SYSCONFIG_14_CHANGE = "disabled";
$SYSCONFIG_14_HELP = '<p>Event forwarding to local syslog</p>';
$SYSCONFIG_14_ACTION = 'grep "^'.$SYSCONFIG_14_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_15_LABEL = "Default ruleset";
$SYSCONFIG_15_NAME = "RSYSLOG_DEFAULT_RULESET_ENABLED";
$SYSCONFIG_15_TYPE = "checkbox";
$SYSCONFIG_15_CHANGE = "disabled";
$SYSCONFIG_15_HELP = '<p>Default ruleset and input listener</p>';
$SYSCONFIG_15_ACTION = 'grep "^'.$SYSCONFIG_15_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_16_LABEL = "TLS ruleset";
$SYSCONFIG_16_NAME = "RSYSLOG_TLS_RULESET_ENABLED";
$SYSCONFIG_16_TYPE = "checkbox";
$SYSCONFIG_16_CHANGE = "disabled";
$SYSCONFIG_16_HELP = '<p>TLS ruleset and input listener</p>';
$SYSCONFIG_16_ACTION = 'grep "^'.$SYSCONFIG_16_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

$SYSCONFIG_17_LABEL = "Nagios ruleset";
$SYSCONFIG_17_NAME = "RSYSLOG_NAGIOS_RULESET_ENABLED";
$SYSCONFIG_17_TYPE = "checkbox";
$SYSCONFIG_17_CHANGE = "disabled";
$SYSCONFIG_17_HELP = '<p>Nagios probe ruleset and input listener</p>';
$SYSCONFIG_17_ACTION = 'grep "^'.$SYSCONFIG_17_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

include("form.inc");

?>
