<?php

/*
 * ELMA SNMP trap setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/snmptrap.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "SNMP trap setup";

$SERVICE_SYSTEMD_NAME = "snmptrapd.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --snmptrap';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "SNMP_TRAP_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable SNMP trap receiver (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "SNMP_TRAP_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of SNMP trap receiver (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_CONFIG_1_LABEL = "Configuration file";
$SERVICE_CONFIG_1_FILE = "/etc/snmp/snmptrapd.conf";
$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SYSCONFIG_1_LABEL = "SNMP_READ_ONLY_COMMUNITY";
$SYSCONFIG_1_NAME = "SNMP_READ_ONLY_COMMUNITY";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "disabled";
$SYSCONFIG_1_HELP = '<p>SNMP read only community</p><ol style="list-style-type:disc";><li>Default value: public</li></ol>';


include("form.inc");

?>
