<?php

/*
 * ELMA webyast setup
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Configuration/webyast.php
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

include("variables.inc");

$SERVICE_TITEL_LABEL = "webyast setup";

$SERVICE_SYSTEMD_NAME = "webyast.service";

$SYSCONFIG_RECONFIGURE_LABEL = (isset($SERVICE_SYSTEMD_NAME)) ? "Reconfigure ".$SERVICE_SYSTEMD_NAME : "Reconfigure service";
$SYSCONFIG_RECONFIGURE_HELP = "";
$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --webyast';

$SERVICE_ENABLED_LABEL = "Enable service";
$SERVICE_ENABLED_NAME = "WEBYAST_ENABLED";
$SERVICE_ENABLED_TYPE = "checkbox";
$SERVICE_ENABLED_CHANGE = "enabled";
$SERVICE_ENABLED_HELP = "Enable WebYaST interface (".$SERVICE_SYSTEMD_NAME.") to be started on bootup";
$SERVICE_ENABLED_ACTION = "systemctl is-enabled ".$SERVICE_SYSTEMD_NAME;

$SERVICE_RUNNING_LABEL = "Running";
$SERVICE_RUNNING_NAME = "WEBYAST_RUNNING";
$SERVICE_RUNNING_TYPE = "checkbox";
$SERVICE_RUNNING_CHANGE = "disabled";
$SERVICE_RUNNING_HELP = "Show the status of WebYaST interface (".$SERVICE_SYSTEMD_NAME."), including whether it is running or not";
$SERVICE_RUNNING_ACTION = "systemctl is-active ".$SERVICE_SYSTEMD_NAME;

$SERVICE_STATUS_1_LABEL = "Status";
$SERVICE_STATUS_1_TYPE = "textarea";
$SERVICE_STATUS_1_ROWS = "6";
$SERVICE_STATUS_1_CHANGE = "disabled";
$SERVICE_STATUS_1_ACTION = "systemctl status ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_1_LABEL = "System log";
$SERVICE_LOG_1_HELP = "";
$SERVICE_LOG_1_FILE = "";
$SERVICE_LOG_1_ACTION = "sudo -u root -S /usr/bin/journalctl --no-pager -r -u ".$SERVICE_SYSTEMD_NAME;

$SERVICE_LOG_2_LABEL = "WebYaST access log";
$SERVICE_LOG_2_FILE = "/var/log/webyast/access.log";
$SERVICE_LOG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_2_FILE;
$SERVICE_LOG_2_HELP = $SERVICE_LOG_2_FILE;

$SERVICE_LOG_3_LABEL = "WebYaST error log";
$SERVICE_LOG_3_FILE = "/var/log/webyast/error.log";
$SERVICE_LOG_3_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_LOG_3_FILE;
$SERVICE_LOG_3_HELP = $SERVICE_LOG_3_FILE;

$SYSCONFIG_1_LABEL = "WEBYAST_PROTOCOL";
$SYSCONFIG_1_NAME = "WEBYAST_PROTOCOL";
$SYSCONFIG_1_TYPE = "text";
$SYSCONFIG_1_CHANGE = "disabled";
$SYSCONFIG_1_HELP = '<p>WebYaST protocol</p><ol style="list-style-type:disc";><li>protocol can be http or https</li><li>Default value: https</li></ol>';

$SYSCONFIG_2_LABEL = "WEBYAST_PORT";
$SYSCONFIG_2_NAME = "WEBYAST_PORT";
$SYSCONFIG_2_TYPE = "text";
$SYSCONFIG_2_CHANGE = "disabled";
$SYSCONFIG_2_HELP = '<p>WebYaST listening tcp port</p><ol style="list-style-type:disc";><li>Default value: 4984</li></ol>';

include("form.inc");

?>
