<?php

/*
 * ELMA Help About
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Help/about.php
 *
 */

defined('is_running') or die('Not an entry point...');

gpPlugin::incl('functions.inc','require_once');

class HelpAbout extends Help {

	function HelpAbout(){

		global $languages, $install_language;
		
		?>
		<h1><a href="http://enterprise-log-management-appliance.org/" target="_blank"><img alt="" src="/data/_uploaded/image/banner_elma.png" /></a></h1>
		<br />
		<?php

		$ELMA_APPLIANCE_VERSION = shell_exec('cat /etc/ImageVersion');
		$ELMA_APPLIANCE_VERSION_DATE = shell_exec('ls -l --time-style=+%Y-%m-%d /etc/ImageVersion | awk -F\' \' \'{print $6}\'');
		$OPENSUSE_VERSION = shell_exec('grep "PRETTY_NAME=" /etc/os-release | awk -F\'=\' \'{print $2}\' | awk -F\'"\' \'{print $2}\'');
		$OPENSUSE_VERSION_DATE = shell_exec('ls -l --time-style=+%Y-%m-%d /etc/os-release | awk -F\' \' \'{print $6}\'');

		echo "<h3>Appliance build</h3>";
		echo "<div class=\"well well-small\">";
		echo "<a href='https://susestudio.com/a/TOYySW/enterprise-log-management-appliance--4' target='_blank'>$ELMA_APPLIANCE_VERSION</a> ($ELMA_APPLIANCE_VERSION_DATE)<br />";
		echo "Based on $OPENSUSE_VERSION ($OPENSUSE_VERSION_DATE)";
		echo "</div>";

		$ELMA_VERSION = shell_exec('rpm -q elma | sed \'s/\ .*$//;s/.\///;s/elma-//\'');
		$ELMA_VERSION_DATE = shell_exec('rpm -qi elma | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$ELMA_VERSION_DATE = shell_exec('date -d "'.$ELMA_VERSION_DATE.'" "+%Y-%m-%d"');

		echo "<h3>Release</h3>";
		echo "<div class=\"well well-small\">";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/elma/elma.changes' target='_blank'>elma</a> - $ELMA_VERSION ($ELMA_VERSION_DATE)";
		echo "</div>";

		$RSYSLOG_VERSION = shell_exec('rpm -q rsyslog | sed \'s/\ .*$//;s/.\///;s/rsyslog-//\'');
		$RSYSLOG_VERSION_DATE = shell_exec('rpm -qi rsyslog | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$RSYSLOG_VERSION_DATE = shell_exec('date -d "'.$RSYSLOG_VERSION_DATE.'" "+%Y-%m-%d"');

		$RSYSLOG_TESTTOOLS_VERSION = shell_exec('rpm -q rsyslog-testtools | sed \'s/\ .*$//;s/.\///;s/rsyslog-testtools-//\'');
		$RSYSLOG_TESTTOOLS_VERSION_DATE = shell_exec('rpm -qi rsyslog-testtools | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$RSYSLOG_TESTTOOLS_VERSION_DATE = shell_exec('date -d "'.$RSYSLOG_TESTTOOLS_VERSION_DATE.'" "+%Y-%m-%d"');

		echo "<h3>Log management services</h3>";
		echo "<div class=\"well well-small\">";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/rsyslog/rsyslog.changes' target='_blank'>rsyslog</a> - $RSYSLOG_VERSION ($RSYSLOG_VERSION_DATE)<br />";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/rsyslog-testtools/rsyslog-testtools.changes' target='_blank'>rsyslog-testtools</a> - $RSYSLOG_TESTTOOLS_VERSION ($RSYSLOG_TESTTOOLS_VERSION_DATE)";
		echo "</div>";

		$ES_VERSION = shell_exec('rpm -q elasticsearch | sed \'s/\ .*$//;s/.\///;s/elasticsearch-//\'');
		$ES_VERSION_DATE = shell_exec('rpm -qi elasticsearch | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$ES_VERSION_DATE = shell_exec('date -d "'.$ES_VERSION_DATE.'" "+%Y-%m-%d"');

		$ES_HEAD_VERSION = shell_exec('rpm -q elasticsearch-plugin-head | sed \'s/\ .*$//;s/.\///;s/elasticsearch-plugin-head-//\'');
		$ES_HEAD_VERSION_DATE = shell_exec('rpm -qi elasticsearch-plugin-head | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$ES_HEAD_VERSION_DATE = shell_exec('date -d "'.$ES_HEAD_VERSION_DATE.'" "+%Y-%m-%d"');

		$ES_BIGDESK_VERSION = shell_exec('rpm -q elasticsearch-plugin-bigdesk | sed \'s/\ .*$//;s/.\///;s/elasticsearch-plugin-bigdesk-//\'');
		$ES_BIGDESK_VERSION_DATE = shell_exec('rpm -qi elasticsearch-plugin-bigdesk | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$ES_BIGDESK_VERSION_DATE = shell_exec('date -d "'.$ES_BIGDESK_VERSION_DATE.'" "+%Y-%m-%d"');

		$ES_PARAMEDIC_VERSION = shell_exec('rpm -q elasticsearch-plugin-paramedic | sed \'s/\ .*$//;s/.\///;s/elasticsearch-plugin-paramedic-//\'');
		$ES_PARAMEDIC_VERSION_DATE = shell_exec('rpm -qi elasticsearch-plugin-paramedic | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$ES_PARAMEDIC_VERSION_DATE = shell_exec('date -d "'.$ES_PARAMEDIC_VERSION_DATE.'" "+%Y-%m-%d"');

		$KIBANA3_VERSION = shell_exec('rpm -q elasticsearch-kibana | sed \'s/\ .*$//;s/.\///;s/elasticsearch-kibana-//\'');
		$KIBANA3_VERSION_DATE = shell_exec('rpm -qi elasticsearch-kibana | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$KIBANA3_VERSION_DATE = shell_exec('date -d "'.$KIBANA3_VERSION_DATE.'" "+%Y-%m-%d"');

		echo "<h3>Log indexing and search services</h3>";
		echo "<div class=\"well well-small\">";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/elasticsearch/elasticsearch.changes' target='_blank'>elasticsearch</a> - $ES_VERSION ($ES_VERSION_DATE)<br />";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/elasticsearch-plugin-head/elasticsearch-plugin-head.changes' target='_blank'>elasticsearch-plugin-head</a> - $ES_HEAD_VERSION ($ES_HEAD_VERSION_DATE)<br />";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/elasticsearch-plugin-bigdesk/elasticsearch-plugin-bigdesk.changes' target='_blank'>elasticsearch-plugin-bigdesk</a> - $ES_BIGDESK_VERSION ($ES_BIGDESK_VERSION_DATE)<br />";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/elasticsearch-plugin-paramedic/elasticsearch-plugin-paramedic.changes' target='_blank'>elasticsearch-plugin-paramedic</a> - $ES_PARAMEDIC_VERSION ($ES_PARAMEDIC_VERSION_DATE)<br />";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/elasticsearch-kibana/elasticsearch-kibana.changes' target='_blank'>elasticsearch-kibana</a> - $KIBANA3_VERSION ($KIBANA3_VERSION_DATE)";
		echo "</div>";

		$NAGIOS_CORE_VERSION = shell_exec('rpm -q nagios | sed \'s/\ .*$//;s/.\///;s/nagios-//\'');
		$NAGIOS_CORE_VERSION_DATE = shell_exec('rpm -qi nagios | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$NAGIOS_CORE_VERSION_DATE = shell_exec('date -d "'.$NAGIOS_CORE_VERSION_DATE.'" "+%Y-%m-%d"');

		echo "<h3>Monitoring services</h3>";
		echo "<div class=\"well well-small\">";
		echo "<a href='https://build.opensuse.org/package/view_file/security:logging:elma/nagios/nagios.changes' target='_blank'>nagios core</a> - $NAGIOS_CORE_VERSION ($NAGIOS_CORE_VERSION_DATE)";
		echo "</div>";

		$APACHE2_VERSION = shell_exec('rpm -q apache2 | sed \'s/\ .*$//;s/.\///;s/apache2-//\'');
		$APACHE2_VERSION_DATE = shell_exec('rpm -qi apache2 | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$APACHE2_VERSION_DATE = shell_exec('date -d "'.$APACHE2_VERSION_DATE.'" "+%Y-%m-%d"');

		$GPEASY_VERSION = shell_exec('grep "Addon_Version = " /srv/www/htdocs/elma/Addon.ini | awk -F\' = \' \'{print $2}\'');

		echo "<h3>Web services</h3>";
		echo "<div class=\"well well-small\">";
		echo "apache - $APACHE2_VERSION ($APACHE2_VERSION_DATE)<br />";
		echo "gpEasy CMS - $GPEASY_VERSION";
		echo "</div>";

		$WEBYAST_VERSION = shell_exec('rpm -q webyast-base | sed \'s/\ .*$//;s/.\///;s/webyast-base-//\'');
		$WEBYAST_VERSION_DATE = shell_exec('rpm -qi webyast-base | grep "Build Date" | awk -F\' : \' \'{print $2}\'');
		$WEBYAST_VERSION_DATE = shell_exec('date -d "'.$WEBYAST_VERSION_DATE.'" "+%Y-%m-%d"');

		echo "<h3>System management services</h3>";
		echo "<div class=\"well well-small\">";
		echo "webyast - $WEBYAST_VERSION ($WEBYAST_VERSION_DATE)";
		echo "</div>";

		?>
		<h3>Support</h3>

		<div class="well well-small">Website: <a href="http://enterprise-log-management-appliance.org" target="_blank">http://enterprise-log-management-appliance.org</a><br />
		Support: <a href="https://github.com/enterprise-log-management-appliance/elma-doc/issues" target="_blank">https://github.com/enterprise-log-management-appliance/elma-doc/issues</a><br />
		Discussion group: <a href="http://groups.google.com/group/enterprise-log-management-appliance" target="_blank">http://groups.google.com/group/enterprise-log-management-appliance</a></div>

		<h3>Development</h3>

		<div class="well well-small">SUSE Studio: <a href="https://susestudio.com/a/TOYySW/enterprise-log-management-appliance--4" target="_blank">https://susestudio.com/a/TOYySW/enterprise-log-management-appliance--4</a><br />
		openSUSE Build Service: <a href="https://build.opensuse.org/project/show/security:logging:elma" target="_blank">https://build.opensuse.org/project/show/security:logging:elma</a><br />
		GitHub: <a href="https://github.com/enterprise-log-management-appliance/elma-doc" target="_blank">https://github.com/enterprise-log-management-appliance/elma-doc</a></div>

		<h3>Copyrights</h3>

		<div class="well well-small">ELMA - <a href="https://build.opensuse.org/package/view_file/security:logging:elma/elma/elma.doc.COPYING" target="_blank">Copyright &copy; 2012-2014 by Joerg Heinemann</a>. Licensed under <a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU GPL v3 or higher</a>.</div>

		<h3>Licenses</h3>

		<p>All of the <a href="https://build.opensuse.org/project/show/security:logging:elma" target="_blank">source code to this project</a> is available under licenses which are both <a href="http://www.gnu.org/philosophy/free-sw.html" target="_blank">free</a> and <a href="http://www.opensource.org/docs/definition.php" target="_blank">open source</a>.<br />
		Most of it is available under <a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU GPL</a> and <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.</p>

		<p>The remainder of the software which is not under the GNU GPL is available under one of a variety of other licenses. Those that require reproduction of the license text in the distribution are given below.<br />
		(Note: your copy of this product may not contain code covered by one or more of the licenses listed here, depending on the exact product and version you choose.)</p>

		<div class="well well-small">
			Apache2 - <a href="http://www.apache.org/licenses/" target="_blank">Copyright &copy; 2012 The Apache Software Foundation</a>. Licensed under <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			Bigdesk - by <a href="https://github.com/lukas-vlcek/bigdesk/blob/master/LICENSE" target="_blank">Lukas Vlcek</a>. Licensed under the <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			Bootstrap - <a href="https://github.com/twitter/bootstrap/blob/master/LICENSE" target="_blank">Copyright &copy; 2012 Twitter, Inc. by Mark Otto and Jacob Thornton</a>. Licensed under <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			elasticsearch - <a href="https://github.com/elasticsearch/elasticsearch/blob/master/LICENSE.txt" target="_blank">Copyright &copy; 2013 All Rights Reserved - Elasticsearch</a>. Licensed under <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			elasticsearch-head - by <a href="https://github.com/mobz/elasticsearch-head/blob/master/LICENCE" target="_blank">Ben Birch</a>. Licensed under the <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			elasticsearch Paramedic - <a href="https://github.com/karmi/elasticsearch-paramedic/blob/master/MIT-LICENSE" target="_blank">Copyright &copy; 2012 by Karel Minarik</a>.<br />
			exfoliation - <a href="http://lancet.mit.edu/mwall/projects/nagios/exfoliation.html" target="_blank">Copyright &copy; 2009-2010 by Matthew Wall</a>. All Rights Reserved.<br />
			Font Awesome - by <a href="http://fortawesome.github.io/Font-Awesome/#license" target="_blank">Dave Gandy</a>.<br />
			Glyphicons FREE - <a href="http://glyphicons.com/glyphicons-licenses/" target="_blank">Copyright &copy; 2010-2013 by Jan Kovarik</a>. Released under <a href="http://creativecommons.org/licenses/by/3.0/deed.en" target="_blank">CC BY 3.0</a>.<br />
			gpEasy CMS - by <a href="https://github.com/oyejorge/gpEasy-CMS/blob/master/README.md" target="_blank">Josh Schmidt</a>. Released under <a href="http://www.gnu.org/licenses/gpl-2.0.html" target="_blank">version 2 of the GNU General Public License</a>.<br />
			Kibana3 - <a href="https://github.com/elasticsearch/kibana3/blob/master/LICENSE.md" target="_blank">Copyright &copy; 2012-2013 Elasticsearch BV</a>. Licensed under the <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			Logstash - <a href="https://github.com/logstash/logstash/blob/master/LICENSE" target="_blank">Copyright &copy; 2009-2013 by Jordan Sissel, Pete Fritchman, and contributors</a>. Licensed under <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a>.<br />
			Nagios - <a href="http://www.nagios.com/legal/licenses" target="_blank">Copyright &copy; 2009-2013 by Nagios Enterprises, LLC</a>. Released under <a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU GPL v2 or higher</a>.<br />
			Nagiosgraph - <a href="http://nagiosgraph.svn.sourceforge.net/viewvc/nagiosgraph/trunk/nagiosgraph/README.html" target="_blank">Copyright &copy; by Soren Dossing, Alan Brenner, Ithaka Harbors and Matthew Wall</a>. Released under the terms of the <a href="http://opensource.org/licenses/artistic-license-2.0" target="_blank">OSI Artistic License 2.0</a>.<br />
			openSUSE - <a href="http://en.opensuse.org/openSUSE:License" target="_blank">Copyright &copy; 2008-2014 The openSUSE Project</a>. All rights reserved.<br />
			Phusion Passenger - <a href="https://github.com/FooBarWidget/passenger/blob/master/LICENSE" target="_blank">Copyright &copy; 2012 Phusion</a>. All Rights Reserved.<br />
			PyES (Python Elastic Search) - by <a href="https://github.com/aparo/pyes/blob/master/LICENSE" target="_blank"> Alberto Paro</a>. Licensed under the New BSD License.<br />
			pynagioscheck - <a href="https://github.com/saj/pynagioscheck/blob/master/LICENCE" target="_blank">Copyright &copy; 2010-2011 by Saj Goonatilleke</a>. All rights reserved.<br />
			rsyslog - <a href="http://www.rsyslog.com/doc/licensing.html" target="_blank">Copyright &copy; 2008 by Rainer Gerhards and Adiscon</a>. Released under <a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU GPL v3 or higher</a>.<br />
			rsyslog testtools - <a href="http://www.rsyslog.com/doc/licensing.html" target="_blank">Copyright &copy; 2008 by Rainer Gerhards and Adiscon</a>. Released under <a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU GPL v3 or higher</a>.<br />
			Sphinx - <a href="http://sphinx-doc.org" target="_blank">Copyright &copy; 2007-2014, Georg Brandl and the Sphinx team</a>. Licensed under the BSD license.<br />
			WL-NagiosPlugins - by <a href="https://github.com/willixix/WL-NagiosPlugins/blob/master/README" target="_blank">William Leibzon</a>. Released under <a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU GPL v2 or higher</a>.
		</div>

		<?php
	} 
}

?>

