<?php

/*
 * ELMA update form
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Update/functions.inc
 *
 */

defined('is_running') or die('Not an entry point...');

global $languages, $install_language;

class Updates {

	function ServiceAction($ACTION, $LABEL, $FILE){

		$ACTION_OUTPUT = "";
		$ERROR_OUTPUT = "";
		$OUTPUT = "";

		exec($ACTION, $OUTPUT, $ERROR);

		foreach($OUTPUT as $LINE) {
			$ACTION_OUTPUT = $ACTION_OUTPUT.htmlentities($LINE)."\n";
		}

		if ($ERROR != 0) $ERROR_OUTPUT = '<div class="alert alert-danger">Error during below action - Please check error messages!</div>';

		$RETURN_OUTPUT = '<a class="show_abstract">'.$LABEL.' '.$FILE.'</a>';
		$RETURN_OUTPUT = $RETURN_OUTPUT.'<div class="abs"><pre>'.$ACTION_OUTPUT.'</pre></div>';

		return array(
			$ERROR_OUTPUT,
			$RETURN_OUTPUT,
		);
	}

	function ReconfigureAction($NAME, $VALUE, $FILE){

		$VALUE=str_replace("&", "\&", $VALUE);

		$ACTION = 'sed -i -e \'/^'.$NAME.'=/s|=.*|=\x27'.$VALUE.'\x27|\' '.$FILE;
		shell_exec($ACTION);
	}

	function UpdateAction($ACTION, $LABEL, $FILE){

		$ERROR_OUTPUT = "";
		$OUTPUT = "";

		$ACTION = exec($ACTION, $OUTPUT, $ERROR);

		foreach($OUTPUT as $LINE) {
			$ACTION = $ACTION.$LINE."\n";
		}

		$OUTPUT = '<a class="show_abstract">'.$LABEL.' '.$FILE.'</a>';
		if ($ERROR != 0) $ERROR_OUTPUT = '<br><div class="alert alert-danger">Error during below action - Please check error messages!</div>';
		$OUTPUT = $OUTPUT.'<div class="abs"><pre>'.$ACTION.'</pre></div>';

		return array(
			$ERROR_OUTPUT,
			$OUTPUT,
		);
	}

	function UpdateTitleField($LABEL){

	 	?><div class="form-group">
			<label class="col-xs-3 control-label"></label>
			<div class="col-xs-9">
			<h1><?php echo $LABEL; ?></h1>
			</div>
		</div> <?php
	}

	function InternetRunningField($ACTION, $NAME, $LABEL, $TYPE, $CHANGE, $HELP){

		exec($ACTION, $OUTPUT, $ERROR); ?>

		<?php if ($ERROR !== 0 and $LABEL == "Internet access") { ?>
			<div class="form-group has-error">
		<?php } elseif ($ERROR == 0){ ?>
			<div class="form-group has-success">
		<?php } else { ?>
			<div class="form-group">
		<?php } ?>
				<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
				<div class="col-xs-4">
					<div class="<?php echo $TYPE; ?>">
						<label>
							<?php if ($ERROR == 0) { ?>
								<input type="<?php echo $TYPE; ?>" name="<?php echo $NAME; ?>" value="Yes" checked <?php echo $CHANGE; ?>>
							<?php } else { ?>
								<input type="<?php echo $TYPE; ?>" name="<?php echo $NAME; ?>" value="Yes" <?php echo $CHANGE; ?>>
							<?php } ?>
						</label>
					</div>
				</div>
				<div class="col-xs-5">
					<span class="help-block">
						<p><?php echo $HELP; ?></p>
					</span>
				</div>
			</div> <?php
	}

	function InternetStatusField($ACTION, $LABEL, $ROWS, $CHANGE){

		$OUTPUT = shell_exec($ACTION); ?>
		<div class="form-group">
			<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
			<div class="col-xs-9">
				<pre><?php echo $OUTPUT; ?></pre>
			</div>
		</div> <?php
	}

	function SubmitButton($LABEL, $NAME, $HELP, $VALUE){

		?><div class="form-group">
			<label class="col-xs-3 control-label"></label>
			<div class="col-xs-4">
				<button type="submit" name="<?php echo $NAME; ?>" value="<?php echo $VALUE; ?>" class="btn btn-default btn-block"><?php echo $LABEL; ?></button>
			</div>
			<div class="col-xs-5">
				<span class="help-block">
					<?php echo $HELP; ?>
				</span>
			</div>
		</div> <?php
	}

	function SysconfigInputField($NAME, $LABEL, $HELP, $TYPE, $CHANGE, $FILE, $ID){

		$VALUE = 'grep "^'.$NAME.'=" '.$FILE.' | awk -F"\'" \'{print $2}\'';
		$VALUE = exec($VALUE); ?>

		<div class="form-group">
			<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
			<div class="col-xs-4">
				<?php if ($TYPE == "text") { ?>
					<input type="<?php echo $TYPE; ?>" class="form-control"<?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" value="<?php echo $VALUE; ?>" <?php echo $CHANGE; ?>>
				<?php } elseif ($TYPE == "checkbox") { ?>
					<div class="<?php echo $TYPE; ?>">
						<label>
							<input type="<?php echo $TYPE; ?>" id="<?php echo $NAME; ?>_1" name="<?php echo $NAME; ?>" value="No" style="display: none;">
							<?php if ( $VALUE == "Yes") { ?>
								<input type="<?php echo $TYPE; ?>" <?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" value="Yes" checked onchange="EnableDisableInput();" <?php echo $CHANGE; ?>>
							<?php } else { ?>
								<input type="<?php echo $TYPE; ?>" <?php if ($CHANGE != "disabled") echo 'id="'.$ID.'"';?> name="<?php echo $NAME; ?>" value="Yes" onchange="EnableDisableInput();" <?php echo $CHANGE; ?>>
							<?php } ?>
						</label>
					</div>
				<?php } ?>
			</div>
			<div class="col-xs-5">
				<span class="help-block">
					<?php echo $HELP; ?>
				</span>
			</div>
		</div> <?php
	}

	function PackageStatusField($ACTION, $ENABLED, $ENABLED_ACTION, $LABEL, $TYPE, $CHANGE, $HELP){

		if ($ENABLED_ACTION !== "") {
			$ENABLED = str_replace("\n","",shell_exec($ENABLED_ACTION));
		}

		exec($ACTION, $OUTPUT, $ERROR); ?>

		<?php if ($ERROR !== 0 and $ENABLED == "Yes") { ?>
			<div class="form-group has-error">
		<?php } elseif ($ERROR == 0){ ?>
			<div class="form-group has-success">
		<?php } else { ?>
			<div class="form-group">
		<?php } ?>
				<label class="col-xs-3 control-label"><?php echo $LABEL; ?></label>
				<div class="col-xs-4">
					<div class="<?php echo $TYPE; ?>">
						<label>
							<?php if ($ERROR == 0) { ?>
								<input type="<?php echo $TYPE; ?>" name="<?php echo $LABEL; ?>" value="Yes" checked <?php echo $CHANGE; ?>>
							<?php } else { ?>
								<input type="<?php echo $TYPE; ?>" name="<?php echo $LABEL; ?>" value="Yes" <?php echo $CHANGE; ?>>
							<?php } ?>
						</label>
					</div>
				</div>
				<div class="col-xs-5">
					<span class="help-block">
						<p><?php echo $HELP; ?></p>
					</span>
				</div>
			</div> <?php
	}

} ?>
