<?php

/*
 * ELMA system updates
 *
 * author: Joerg Heinemann
 * website: http://enterprise-log-management-appliance.org
 * license: GPL v3
 *
 * /srv/www/htdocs/elma/addons/ELMA Update/system.php
 *
 */

defined('is_running') or die('Not an entry point...');

gpPlugin::incl('functions.inc','require_once');

class UpdateSystem extends Updates {

	function UpdateSystem(){

		global $languages, $install_language;
		include("variables.inc");

		$UPDATE_TITEL_LABEL = "System updates";

		$SYSCONFIG_RECONFIGURE_LABEL = "Save and reconfigure repositories";
		$SYSCONFIG_RECONFIGURE_HELP = "Reconfigure system distribution repositories";
		$SYSCONFIG_RECONFIGURE_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --repositories';

		$UPDATE_RUNNING_LABEL = "Internet access";
		$UPDATE_RUNNING_NAME = "PROXY_RUNNING";
		$UPDATE_RUNNING_TYPE = "checkbox";
		$UPDATE_RUNNING_CHANGE = "disabled";
		$UPDATE_RUNNING_HELP = "Show the status of internet reachability";
		$UPDATE_RUNNING_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --internet';

		$UPDATE_STATUS_1_LABEL = "Status";
		$UPDATE_STATUS_1_TYPE = "textarea";
		$UPDATE_STATUS_1_ROWS = "3";
		$UPDATE_STATUS_1_CHANGE = "disabled";
		$UPDATE_STATUS_1_ACTION = 'sudo -u root -S '.$ELMA_BIN_DIR.'/elma-reconfigure.sh --internet';

		$UPDATE_STATUS_2_LABEL = "Repositories";
		$UPDATE_STATUS_2_TYPE = "textarea";
		$UPDATE_STATUS_2_ROWS = "8";
		$UPDATE_STATUS_2_CHANGE = "disabled";
		$UPDATE_STATUS_2_ACTION = 'sudo -u root -S zypper --table-style 11 lr ; echo ; sudo -u root -S zypper -n --no-gpg-checks --gpg-auto-import-keys refresh';

		$UPDATE_STATUS_3_LABEL = "Package Locks";
		$UPDATE_STATUS_3_TYPE = "textarea";
		$UPDATE_STATUS_3_ROWS = "8";
		$UPDATE_STATUS_3_CHANGE = "disabled";
		$UPDATE_STATUS_3_ACTION = 'sudo -u root -S zypper locks';

		$UPDATE_STATUS_4_LABEL = "Needed Patches";
		$UPDATE_STATUS_4_TYPE = "textarea";
		$UPDATE_STATUS_4_ROWS = "8";
		$UPDATE_STATUS_4_CHANGE = "disabled";
		$UPDATE_STATUS_4_ACTION = 'sudo -u root -S /usr/bin/zypper -n --no-gpg-checks --gpg-auto-import-keys lp';

		$UPDATE_STATUS_5_LABEL = "Available Updates";
		$UPDATE_STATUS_5_TYPE = "textarea";
		$UPDATE_STATUS_5_ROWS = "8";
		$UPDATE_STATUS_5_CHANGE = "disabled";
		$UPDATE_STATUS_5_ACTION = 'sudo -u root -S /usr/bin/zypper -n --no-gpg-checks --gpg-auto-import-keys lu';

		$SYSCONFIG_1_LABEL = "Package Lock";
		$SYSCONFIG_1_NAME = "ELMA_PACKAGE_LOCK_ENABLED";
		$SYSCONFIG_1_TYPE = "checkbox";
		$SYSCONFIG_1_CHANGE = "enabled";
		$SYSCONFIG_1_HELP = '<p>Lock ELMA packages to prevent changes to the packages on the system</p>';
		$SYSCONFIG_1_ACTION = 'grep "^'.$SYSCONFIG_1_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

		$SYSCONFIG_2_LABEL = "ELMA devel repository";
		$SYSCONFIG_2_NAME = "ELMA_DEVEL_REPOSITORY_ENABLED";
		$SYSCONFIG_2_TYPE = "checkbox";
		$SYSCONFIG_2_CHANGE = "enabled";
		$SYSCONFIG_2_HELP = '<p>Enable ELMA devel repository</p>';
		$SYSCONFIG_2_ACTION = 'grep "^'.$SYSCONFIG_2_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

		$SYSCONFIG_3_LABEL = "ELMA devel repository URI";
		$SYSCONFIG_3_NAME = "ELMA_REPOSITORY_DEVEL";
		$SYSCONFIG_3_TYPE = "text";
		$SYSCONFIG_3_CHANGE = "enabled";
		$SYSCONFIG_3_HELP = '<p>ELMA devel repository URI</p>';
		$SYSCONFIG_3_ACTION = 'grep "^'.$SYSCONFIG_3_NAME.'=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';

		$PACKAGE_STATUS_1_LABEL = "elma";
		$PACKAGE_STATUS_1_ENABLED = "Yes";
		$PACKAGE_STATUS_1_ENABLED_ACTION = '';
		$PACKAGE_STATUS_1_TYPE = "checkbox";
		$PACKAGE_STATUS_1_CHANGE = "disabled";
		$PACKAGE_STATUS_1_HELP = '<p>Show the installation status of ELMA main package</p>';
		$PACKAGE_STATUS_1_ACTION = 'zypper search -i --match-exact elma';

		$PACKAGE_STATUS_2_LABEL = "elma-devel";
		$PACKAGE_STATUS_2_ENABLED = "";
		$PACKAGE_STATUS_2_ENABLED_ACTION = '';
		$PACKAGE_STATUS_2_TYPE = "checkbox";
		$PACKAGE_STATUS_2_CHANGE = "disabled";
		$PACKAGE_STATUS_2_HELP = '<p>Show the installation status of ELMA development components</p>';
		$PACKAGE_STATUS_2_ACTION = 'zypper search -i --match-exact elma-devel';

		$PACKAGE_STATUS_3_LABEL = "elma-doc";
		$PACKAGE_STATUS_3_ENABLED = "Yes";
		$PACKAGE_STATUS_3_ENABLED_ACTION = '';
		$PACKAGE_STATUS_3_TYPE = "checkbox";
		$PACKAGE_STATUS_3_CHANGE = "disabled";
		$PACKAGE_STATUS_3_HELP = '<p>Show the installation status of ELMA documentation</p>';
		$PACKAGE_STATUS_3_ACTION = 'zypper search -i --match-exact elma-doc';

		$PACKAGE_STATUS_4_LABEL = "elma-elasticsearch";
		$PACKAGE_STATUS_4_ENABLED = "";
		$PACKAGE_STATUS_4_ENABLED_ACTION = 'grep "^ES_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_4_TYPE = "checkbox";
		$PACKAGE_STATUS_4_CHANGE = "disabled";
		$PACKAGE_STATUS_4_HELP = '<p>Show the installation status of elasticsearch components</p>';
		$PACKAGE_STATUS_4_ACTION = 'zypper search -i --match-exact elma-elasticsearch';

		$PACKAGE_STATUS_5_LABEL = "elma-elasticsearch-kibana";
		$PACKAGE_STATUS_5_ENABLED = "";
		$PACKAGE_STATUS_5_ENABLED_ACTION = 'grep "^KIBANA3_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_5_TYPE = "checkbox";
		$PACKAGE_STATUS_5_CHANGE = "disabled";
		$PACKAGE_STATUS_5_HELP = '<p>Show the installation status of elasticsearch-kibana components</p>';
		$PACKAGE_STATUS_5_ACTION = 'zypper search -i --match-exact elma-elasticsearch-kibana';

		$PACKAGE_STATUS_6_LABEL = "elma-logstash";
		$PACKAGE_STATUS_6_ENABLED = "";
		$PACKAGE_STATUS_6_ENABLED_ACTION = 'grep "^LOGSTASH_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_6_TYPE = "checkbox";
		$PACKAGE_STATUS_6_CHANGE = "disabled";
		$PACKAGE_STATUS_6_HELP = '<p>Show the installation status of logstash components</p>';
		$PACKAGE_STATUS_6_ACTION = 'zypper search -i --match-exact elma-logstash';

		$PACKAGE_STATUS_7_LABEL = "elma-nagios";
		$PACKAGE_STATUS_7_ENABLED = "";
		$PACKAGE_STATUS_7_ENABLED_ACTION = 'grep "^NAGIOS_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_7_TYPE = "checkbox";
		$PACKAGE_STATUS_7_CHANGE = "disabled";
		$PACKAGE_STATUS_7_HELP = '<p>Show the installation status of Nagios components</p>';
		$PACKAGE_STATUS_7_ACTION = 'zypper search -i --match-exact elma-nagios';

		$PACKAGE_STATUS_8_LABEL = "elma-rsyslog";
		$PACKAGE_STATUS_8_ENABLED = "";
		$PACKAGE_STATUS_8_ENABLED_ACTION = 'grep "^RSYSLOG_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_8_TYPE = "checkbox";
		$PACKAGE_STATUS_8_CHANGE = "disabled";
		$PACKAGE_STATUS_8_HELP = '<p>Show the installation status of rsyslog components</p>';
		$PACKAGE_STATUS_8_ACTION = 'zypper search -i --match-exact elma-rsyslog';

		$PACKAGE_STATUS_9_LABEL = "elma-tests";
		$PACKAGE_STATUS_9_ENABLED = "";
		$PACKAGE_STATUS_9_ENABLED_ACTION = 'grep "^RSYSLOG_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_9_TYPE = "checkbox";
		$PACKAGE_STATUS_9_CHANGE = "disabled";
		$PACKAGE_STATUS_9_HELP = '<p>Show the installation status of testing components</p>';
		$PACKAGE_STATUS_9_ACTION = 'zypper search -i --match-exact elma-tests';

		$PACKAGE_STATUS_10_LABEL = "elma-webyast";
		$PACKAGE_STATUS_10_ENABLED = "";
		$PACKAGE_STATUS_10_ENABLED_ACTION = 'grep "^WEBYAST_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_10_TYPE = "checkbox";
		$PACKAGE_STATUS_10_CHANGE = "disabled";
		$PACKAGE_STATUS_10_HELP = '<p>Show the installation status of webyast components</p>';
		$PACKAGE_STATUS_10_ACTION = 'zypper search -i --match-exact elma-webyast';

		$PACKAGE_STATUS_11_LABEL = "elma-www";
		$PACKAGE_STATUS_11_ENABLED = "";
		$PACKAGE_STATUS_11_ENABLED_ACTION = 'grep "^APACHE2_ENABLED=" '.$ELMA_CONF.' | awk -F"\'" \'{print $2}\'';
		$PACKAGE_STATUS_11_TYPE = "checkbox";
		$PACKAGE_STATUS_11_CHANGE = "disabled";
		$PACKAGE_STATUS_11_HELP = '<p>Show the installation status of WWW components</p>';
		$PACKAGE_STATUS_11_ACTION = 'zypper search -i --match-exact elma-www';

		$PACKAGE_STATUS_12_LABEL = "elma-yast2";
		$PACKAGE_STATUS_12_ENABLED = "Yes";
		$PACKAGE_STATUS_12_ENABLED_ACTION = '';
		$PACKAGE_STATUS_12_TYPE = "checkbox";
		$PACKAGE_STATUS_12_CHANGE = "disabled";
		$PACKAGE_STATUS_12_HELP = '<p>Show the installation status of yast2 components</p>';
		$PACKAGE_STATUS_12_ACTION = 'zypper search -i --match-exact elma-yast2';

		$SERVICE_CONFIG_1_LABEL = "Zypper sysconfig";
		$SERVICE_CONFIG_1_FILE = "/etc/zypp/zypper.conf";
		$SERVICE_CONFIG_1_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_1_FILE;
		$SERVICE_CONFIG_1_HELP = $SERVICE_CONFIG_1_FILE;

		$SERVICE_CONFIG_2_LABEL = "Zypper software management";
		$SERVICE_CONFIG_2_FILE = "/etc/zypp/zypp.conf";
		$SERVICE_CONFIG_2_ACTION = "sudo -u root -S /usr/bin/cat ".$SERVICE_CONFIG_2_FILE;
		$SERVICE_CONFIG_2_HELP = $SERVICE_CONFIG_2_FILE;

		$UPDATE_1_LABEL = "Install / Reinstall";
		$UPDATE_1_SCRIPT = $ELMA_BIN_DIR.'/elma-reconfigure.sh --install';
		$UPDATE_1_ACTION = 'sudo -u root -S '.$UPDATE_1_SCRIPT;
		$UPDATE_1_HELP = "Install / Reinstall needed system packages";

		$UPDATE_2_LABEL = "Patch";
		$UPDATE_2_SCRIPT = $ELMA_BIN_DIR.'/elma-reconfigure.sh --patch';
		$UPDATE_2_ACTION = 'sudo -u root -S '.$UPDATE_2_SCRIPT;
		$UPDATE_2_HELP = "Apply needed patches";

		$UPDATE_3_LABEL = "Update";
		$UPDATE_3_SCRIPT = $ELMA_BIN_DIR.'/elma-reconfigure.sh --update';
		$UPDATE_3_ACTION = 'sudo -u root -S '.$UPDATE_3_SCRIPT;
		$UPDATE_3_HELP = "Update system packages to newest available versions";

		$REBOOT_LABEL = "Reboot";
		$REBOOT_SCRIPT = 'reboot -f &';
		/* $REBOOT_SCRIPT = $ELMA_BIN_DIR.'/elma-reconfigure.sh --reboot'; */
		$REBOOT_ACTION = 'sudo -u root -S '.$REBOOT_SCRIPT;
		$REBOOT_HELP = "System reboot";

		include("form.inc");

	} 
}

?>

