<?php
/**
 * name:      BreadcrumbNavigation.php
 * date:      04.09.2010
 * author:    Stefan Benicke
 * copyright: Stefan Benicke <http://www.opusonline.at>
 */
defined('is_running') or die('Not an entry point...');

function BreadcrumbNavigation() {
	global $gp_menu, $page, $gp_index;
	global $gpmenu, $page;

	$output = array();
	$thisLevel = -1;
	$lastTitle = '';

	//2.0+
	if( isset($gp_menu) && is_array($gp_menu) ){
		$rmenu = array_reverse($gp_menu);
		foreach($rmenu as $index => $info){
			$level = $info['level'];
	
			$title = common::IndexToTitle($index);
			
			if ($thisLevel >= 0) {
				if ($thisLevel == $level) {
					$output[] = $title;
					$lastTitle = $title;
					if ($thisLevel == 0) {
						break;
					}
					$thisLevel--;
				}
			}
			
			if ($title == $page->title) {
				$output[] = $title;
				$thisLevel = $level-1;
				$lastTitle = $title;
			}
		}
		
		reset($gp_menu);
		$first_index = key($gp_menu);
		$first_title = common::IndexToTitle($first_index);
		if($lastTitle != $first_title ){
			$output[] = $first_title;
		}

	}else{
		
		$rmenu = array_reverse($gpmenu);
		
		foreach ($rmenu as $title => $level) {
			if ($thisLevel >= 0) {
				if ($thisLevel == $level) {
					$output[] = $title;
					$lastTitle = $title;
					if ($thisLevel == 0) {
						break;
					}
					$thisLevel--;
				}
			}
			if ($title == $page->title) {
				$output[] = $title;
				$thisLevel = $level-1;
				$lastTitle = $title;
			}
		}
		reset($gpmenu);
		if ($lastTitle != key($gpmenu)) {
			$output[] = key($gpmenu);
		}
	}
	
	for ($i = (count($output)-1); $i >= 0; $i--) {
		$label = common::GetLabel($output[$i], false);
		if ($i > 0) {
			echo common::Link($output[$i], $label);
			echo gpOutput::GetAddonText(' &gt; ');
		}
		else {
			echo '<span class="selected">'.common::Link($output[$i], $label).'</span>';
		}
	}
}

BreadcrumbNavigation();
