<?php
defined('is_running') or die('Not an entry point...');
$fileVersion = '4.3.2';
$fileModTime = '1393157836';
$file_stats = array (
  'created' => 1392316385,
  'gpversion' => '4.3.2',
  'modified' => 1393157836,
  'username' => 'admin',
);

$meta_data = array (
  'file_number' => 33,
  'file_type' => 'text',
);

$file_sections = array (
  0 => 
  array (
    'type' => 'text',
    'content' => '<div id="wikipage">
<table>
	<tbody>
		<tr>
			<td>
			<div id="wikiheader"><span style="font-size:120%;font-weight:bold">About</span> &nbsp;

			<div><i>Project overview</i><br />
			<a class="label" href="http://code.google.com/p/enterprise-log-management-appliance/w/list?q=label:Featured" style="padding-top: 2px" target="_blank" title="Listed on project home page">Featured</a></div>
			</div>

			<div id="wikicontent">
			<div class="vt" id="wikimaincol">
			<h1><a name="Introduction"></a>Introduction</h1>

			<p>ELMA is a <strong>logging and syslog framework</strong> complemented by a range of free and open-source tools that can help you aggregate and deliver metrics, analytics and vital performance data.</p>

			<p>Log normalization and a <a href="/data/_uploaded/image/wiki/kibana-search.png">web-based query interface</a> makes searching billions of log events for arbitrary strings as easy as searching the web.</p>

			<p>Provided as an <a href="http://susestudio.com/a/TOYySW/enterprise-log-management-appliance--2" target="_blank">preinstalled openSUSE appliance</a> which can be <a href="/wiki/Installation.html">deployed and customized</a> in a few minutes ELMA comes out of the box with all necessary services, <a href="/wiki/Configuration.html">fine customization and performance tuning</a> and allows easy <a href="/wiki/Administration.html">adminstration</a> and <a href="/wiki/Operation.html">operations</a>.</p>

			<p>Issues, problems, enhancements and feature requests are managed with <a href="http://code.google.com/p/enterprise-log-management-appliance/issues/list" target="_blank">ELMA project workflow</a>.<br />
			For extended communication please visit <a href="https://groups.google.com/forum/?fromgroups#!forum/enterprise-log-management-appliance" target="_blank">ELMA discussion group</a>.</p>

			<p>At the moment we review and completly rewrite our wiki - <strong>Every help is welcome</strong>.</p>

			<h1><a name="Overview"></a>Overview</h1>

			<h3><a name="Ingredients"></a>Ingredients</h3>

			<ul>
				<li><a href="http://susestudio.com/a/TOYySW/enterprise-log-management-appliance--2" target="_blank">ELMA</a> - Enterprise Log Management Appliance</li>
				<li><a href="http://www.rsyslog.com/" target="_blank">rsyslog</a> - Enhanced syslogd for Linux and Unix</li>
				<li><a href="http://logstash.net" target="_blank">logstash</a> - Managing events and logs</li>
				<li><a href="http://httpd.apache.org/" target="_blank">Apache httpd</a> - Support SSL, basic authentication and log all or some incoming requests in plain text or json formats</li>
				<li><a href="http://www.elasticsearch.org" target="_blank">ElasticSearch</a> - Distributed, RESTful and full-text indexing and search engine based on <a href="https://lucene.apache.org" target="_blank">Apache Lucene</a>
				<ul>
					<li><a href="https://github.com/mobz/elasticsearch-head#readme" target="_blank">ElasticSearch Head</a> - Browsing and interacting with ElasticSearch clusters</li>
					<li><a href="https://github.com/lukas-vlcek/bigdesk/#readme" target="_blank">ElasticSearch BigDesk</a> - Live charts and statistics for ElasticSearch clusters</li>
					<li><a href="https://github.com/karmi/elasticsearch-paramedic#readme" target="_blank">ElasticSearch Paramedic</a> - Monitors and inspect ElasticSearch clusters</li>
				</ul>
				</li>
				<li><a href="http://kibana.org" target="_blank">Kibana</a> - User frontend that allows search, graph, analyze and otherwise make sense of a mountain of logs</li>
			</ul>

			<h3><a name="Cookbook"></a>Cookbook</h3>

			<p><strong>Ship logs from any source</strong>, get the right timestamp, parse and normalize them into structured JSON format, index them:</p>

			<p><img alt="" src="/data/_uploaded/image/wiki/syslog-infrastructure.png" /></p>

			<h3><a name="Menue"></a>Menue</h3>

			<p><strong>All your logs</strong> and other event data from all over your infrastructure <strong>in a central place</strong> - <a href="/data/_uploaded/image/wiki/kibana-search.png">Search, graph and analyse</a> them.</p>

			<p><img alt="" src="/data/_uploaded/image/wiki/kibana-chart.png" /></p>

			<h1><a name="Details"></a>Details</h1>

			<h3><a name="Syslog_evolution"></a>Syslog evolution</h3>

			<p>Rsyslog default flat file ASCII log format is not exactly the most efficient way for searching large volumes of data.<br />
			For longer historical retention as you can see below - it&#39;s not so bad.</p>

			<p>Logging into traditional relational databases is not scalable if your amount of data gets higher then 1.000 - 2.000 events/second because of missing full-text indexing and poor full-text search capabilities - <strong>Search of Death</strong>.</p>

			<p>Projects like <a href="http://sphinxsearch.com/" target="_blank">Sphinx</a> addresses this issues but implementations are complicated. You have to adapt all SQL based applications.</p>

			<p>Logging is mostly done too unstructured. No consistent application log schema or syntax, no consistent way of routing, filtering, indexing and searching. <strong>No real standard on how to format and structure data</strong> on a syslog message.</p>

			<p>Log normalization with <a href="http://www.rsyslog.com/normalizer-first-steps-for-mmnormalize/" target="_blank">rsyslog mmnormalize</a> helps to parse unstructured messages but further limitations are the <strong>static database models</strong>.</p>

			<p>It&#39;s <strong>time for change</strong>.</p>

			<h3><a name="Next_generation_databases"></a>Next generation databases</h3>

			<p><a href="http://www.elasticsearch.org" target="_blank">ElasticSearch</a> is a new data storage technology for dealing with tons of data. Itâ&euro;&trade;s also a search engine built on top of <a href="https://lucene.apache.org" target="_blank">Apacheâ&euro;&trade;s Lucene project</a>. It scales very well, both for distributed full-text indexing and distributed searching.</p>

			<p>It&#39;s search engine&#39;s data model is <a href="http://json.org/" target="_blank">JSON</a>, which is the de-facto standard for representing data these days. It&#39;s roots lie with schema-free and <a href="http://en.wikipedia.org/wiki/Document-oriented_database" target="_blank">document-oriented databases</a>, and as shown by the <a href="http://en.wikipedia.org/wiki/NoSQL" target="_blank">NoSQL movement</a>, this model proves very effective for building applications.</p>

			<p>Moreover, with JSON it is simple to provide <a href="http://en.wikipedia.org/wiki/Semi-structured_model" target="_blank">semi-structured data</a> with complex entities as well as being programming language neutral with first-level parser support.</p>

			<h3><a name="Common_Event_Expression_-_CEE_enhanced_syslog"></a>Common Event Expression - CEE enhanced syslog</h3>

			<p>On <a href="https://fedorahosted.org/lumberjack/" target="_blank">syslog community</a> also interesting stuff is happening and more precisely on the topic of syslog format extension and structuring syslog data.</p>

			<p>The main idea about <a href="http://blog.gerhards.net/2012/02/announcing-project-lumberjack.html" target="_blank">structuring syslog messages</a> is to represent them using JSON along with the current free form strings to prevent backward compatibility breakage. Therefore this format has to be normalized and extended so that syslog softwares such as rsyslog and syslog-ng can directly understand them. Thatâ&euro;&trade;s where <a href="http://cee.mitre.org" target="_blank">CEE enhanced syslog</a> and <a href="https://fedorahosted.org/lumberjack/" target="_blank">Lumberjack</a> kick in.</p>

			<h3><a name="Our_goal"></a>Our goal</h3>

			<p>The first part should be the rulebase which holds format representations of expected log messages. This permits very high performance normalization of semantically equal messages from different devices (and thus in different syntaxes).</p>

			<p>Parse and normalize events into structured JSON format via rsyslog mmnormalize and mmjsonparse.</p>

			<p>Rsyslog new omelasticsearch module ships your logs nearly in real time into a ElasticSearch cluster by using ElasticSearch bulk API for indexing. With bulk mode, message processing is much faster, especially if large loads are to be processed.</p>

			<p>Kibana user frontend queries the REST interface of ElasticSearch. It provides <strong>enterprise wide</strong> â&euro;&uml;full-text search and allows you to plot, calculate and drill down into your rsyslog <a href="http://www.elasticsearch.org/tutorials/2012/05/19/elasticsearch-for-logging.html" target="_blank">timebased indexed logging data</a>.</p>

			<p><img alt="" src="/data/_uploaded/image/wiki/kibana-search.png" /></p>

			<p><strong>Enjoy the performance</strong>, it&#39;s very awesome - really.</p>

			<h3><a name="Why_not_just_archive_everything_in_ElasticSearch_?"></a>Why not just archive everything in ElasticSearch?</h3>

			<p>That&#39;s an option, however rsyslog flat files are much easier to handle. Compressed rsyslog flat files are 90% or less of the size of compressed ElasticSearch documents.</p>

			<p>Assuming an average message lenght of 244 Byte per message and 10.000 events per second the following projection can give you an idea of difficulties for suitable filesystem sizing:</p>

			<p>&nbsp;</p>

			<table class="wikitable">
				<tbody>
					<tr>
						<td style="border: 1px solid #ccc; padding: 5px;">&nbsp;</td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>Benchmark</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>second</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>minute</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>hour</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>day</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>week</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>month</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>year</b></td>
					</tr>
					<tr>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>Messages</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;">&nbsp;</td>
						<td style="border: 1px solid #ccc; padding: 5px;">10 k</td>
						<td style="border: 1px solid #ccc; padding: 5px;">600 k</td>
						<td style="border: 1px solid #ccc; padding: 5px;">36 M</td>
						<td style="border: 1px solid #ccc; padding: 5px;">864 M</td>
						<td style="border: 1px solid #ccc; padding: 5px;">6.048 M</td>
						<td style="border: 1px solid #ccc; padding: 5px;">181.440 M</td>
						<td style="border: 1px solid #ccc; padding: 5px;">2.177.280 M</td>
					</tr>
					<tr>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>Compressed data size</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;">omfile</td>
						<td style="border: 1px solid #ccc; padding: 5px;">0.03 MB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">1.74 MB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">104.40 MB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">2.45 GB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">17.13 GB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">68.51 GB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">822.15 GB</td>
					</tr>
					<tr>
						<td style="border: 1px solid #ccc; padding: 5px;"><b>Compressed data size</b></td>
						<td style="border: 1px solid #ccc; padding: 5px;">omelasticsearch</td>
						<td style="border: 1px solid #ccc; padding: 5px;">3.50 MB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">210.00 MB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">12.30 GB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">295.31 GB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">2.02 TB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">8.07 TB</td>
						<td style="border: 1px solid #ccc; padding: 5px;">96.90 TB</td>
					</tr>
				</tbody>
			</table>

			<p>&nbsp;</p>

			<p>For further details have a look into ELMA <a href="/wiki/Tests.html">performance and compression tests</a>.</p>

			<p>If you have a large volume of logs and you intend on keeping them around for compliance reasons for a long period of time archiving in rsyslog flat files allows longer historical retention.</p>

			<h3><a name="Why_ELMA?"></a>Why ELMA?</h3>

			<p>Provided as an <a href="http://susestudio.com/a/TOYySW/enterprise-log-management-appliance--2" target="_blank">preinstalled openSUSE appliance</a> which can be <a href="/wiki/Installation.html">deployed and customized</a> in a few minutes ELMA comes out of the box with all necessary services, <a href="/wiki/Configuration.html">fine customization and performance tuning</a> and allows easy <a href="/wiki/Administration.html">adminstration</a> and <a href="/wiki/Operation.html">operations</a>:</p>

			<ul>
				<li>Parse events into structured JSON format</li>
				<li>Log router - route between different input and output sources</li>
			</ul>

			<ul>
				<li>Daily based indexes</li>
				<li>Optimization of time-based indices</li>
				<li>Logrotation (delete old indexes)</li>
			</ul>

			<ul>
				<li>Basic HTTP authentication on all backends and frontends</li>
				<li>Apache authentication, authorisation and accounting (AAA) functionality</li>
				<li>LDAP and RADIUS integration</li>
				<li>SSL Offloading</li>
				<li>Loadbalancing</li>
				<li>Single Logon</li>
			</ul>

			<ul>
				<li>Admin interfaces</li>
				<li>Design your own custom dashboards with configurable panels</li>
				<li>System monitoring due to Nagios Core integration</li>
				<li>Rsyslog and ElasticSearch and other serviceable probes</li>
			</ul>

			<ul>
				<li>Performance - ext4 filesystem</li>
				<li>Operation - bind, ntp, snmp and snmptrap integration</li>
			</ul>

			<ul>
				<li><a href="/wiki/Tests.html">performance and compression tests</a></li>
			</ul>

			<ul>
				<li>Flexible integrations - <a href="/wiki/Requirements.html">vmesx, xen, hardware</a></li>
				<li>Vertical and horizontal scalable</li>
			</ul>

			<p>Look at ELMA <a href="/wiki/Loadbalancing.html">Loadbalancing and Redundancy Guide</a> - a good starting point for understanding the communication matrix inside ELMA.</p>

			<h3><a name="Howto_integrate_into_your_existing_logging_and_monitoring_infras"></a>Howto integrate into your existing logging and monitoring infrasructure?</h3>

			<p>Many organizations already have centralized syslog server and are comfortable with collecting logs this way. There are many good reasons to do this even if you want to use an infrastructure like ELMA provides. Simply forward these syslog events to the central ELMA infrastructure to combine the benefits of both sides.</p>

			<p>At <a href="http://kibana.org" target="_blank">Kibana Home</a> you&#39;ll find an <a href="http://kibana.org/infrastructure.html" target="_blank">additional log analysis infrastructure overview</a> that also can be dropped directly into existing centralized syslog systems, without affecting legacy applications.</p>

			<p><strong>Further event forwarding to your favorite SIEM system make sense!</strong></p>
			</div>
			</div>
			</td>
		</tr>
		<tr>
		</tr>
	</tbody>
</table>
</div>
',
    'resized_imgs' => 
    array (
    ),
    'modified' => 1392679801,
    'modified_by' => 'admin',
  ),
);

