<?php
defined('is_running') or die('Not an entry point...');
$fileVersion = '4.3.2';
$fileModTime = '1393159728';
$file_stats = array (
  'created' => 1392316385,
  'gpversion' => '4.3.2',
  'modified' => 1393159728,
  'username' => 'admin',
);

$meta_data = array (
  'file_number' => 33,
  'file_type' => 'text',
);

$file_sections = array (
  0 => 
  array (
    'type' => 'text',
    'content' => '<div id="wikipage">
<table>
	<tbody>
		<tr>
			<td>
			<div id="wikiheader"><span style="font-size:120%;font-weight:bold">Loadbalancing</span> &nbsp;
			<div><i>Loadbalancing and redundancy Guide</i></div>
			</div>

			<div id="wikicontent">
			<div class="vt" id="wikimaincol">
			<h1><a name="Introduction"></a>Introduction</h1>

			<p>This HOWTO explains the communication matrix, loadbalancing and redundancy concepts inside ELMAs components:</p>

			<ul>
				<li><a href="http://susestudio.com/a/TOYySW/enterprise-log-management-appliance--2" target="_blank">ELMA</a> - Enterprise Log Management Appliance</li>
				<li><a href="http://www.rsyslog.com/" target="_blank">rsyslog</a> - Enhanced syslogd for Linux and Unix</li>
				<li><a href="http://logstash.net" target="_blank">logstash</a> - Managing events and logs</li>
				<li><a href="http://httpd.apache.org/" target="_blank">Apache httpd</a> - Support SSL, basic authentication and log all or some incoming requests in plain text or json formats</li>
				<li><a href="http://www.elasticsearch.org" target="_blank">ElasticSearch</a> - Distributed, RESTful and full-text indexing and search engine based on <a href="https://lucene.apache.org" target="_blank">Apache Lucene</a>
				<ul>
					<li><a href="https://github.com/mobz/elasticsearch-head#readme" target="_blank">ElasticSearch Head</a> - Browsing and interacting with ElasticSearch clusters</li>
					<li><a href="https://github.com/lukas-vlcek/bigdesk/#readme" target="_blank">ElasticSearch BigDesk</a> - Live charts and statistics for ElasticSearch clusters</li>
					<li><a href="https://github.com/karmi/elasticsearch-paramedic#readme" target="_blank">ElasticSearch Paramedic</a> - Monitors and inspect ElasticSearch clusters</li>
				</ul>
				</li>
				<li><a href="http://kibana.org" target="_blank">Kibana</a> - User frontend that allows search, graph, analyze and otherwise make sense of a mountain of logs</li>
			</ul>

			<h1><a name="Details"></a>Details</h1>

			<p><img src="/data/_uploaded/image/wiki/syslog-loadbalancing.png" alt="" /></p>

			<p><a href="http://wiki.rsyslog.com/index.php/FailoverSyslogServer" target="_blank">http://wiki.rsyslog.com/index.php/FailoverSyslogServer</a></p>

			<p>Here is a simple overview on deploying ElasticSearch on multiple servers with dedicated roles:</p>

			<ul>
				<li>Master (can be an Elasticsearch master, acts as load balancer on the cluster, doesn&#39;t store data and can use the http transport)</li>
				<li>Slave (a data node, can not be an Elasticsearch master and can not use the http transport)</li>
				<li>Monitor (doesn&#39;t store data, can not be an Elasticsearch master, hold plugins and can use the http transport. By default, uses the paramedic plugin)</li>
			</ul>

			<p>&nbsp;</p>

			<p>&quot;A master in elasticsearch is responsible for handling nodes coming and going and allocation of shards.&quot; (quoting Shay)</p>

			<p>Now here comes my own understanding:</p>

			<p>A master may hold data or not. A &quot;load balancer&quot; would be a node that doesn&#39;t hold data (node.data: false), but has the HTTP transport enabled. From what I know it doesn&#39;t need to be a master as well. The idea is that client apps would send requests to it, and the load balancer would forward the requests to the nodes having the needed shards, and also gather the results.</p>

			<p>Then, you would have &quot;load balanced&quot; nodes, if you will. Those would be nodes that hold data, but with HTTP transport disabled (http.enabled: false). They will only be &quot;workhorses&quot; and won&#39;t be bothered with stuff like HTTP requests for clients or redirecting requests to other data nodes.</p>

			<p>node.master set to true means that node can be elected to become a master in cluster. node.data set to true means that a node will be allocated with shards (&quot;data&quot;). Setting both to false (or simply setting node.client to true) will cause the node to act as a client to the cluster, potentially acting as a load balancer.</p>

			<ul>
				<li><a href="http://vincentdevillers.blogspot.de/2013/04/how-to-deploy-elasticsearch-cluster.html" target="_blank">http://vincentdevillers.blogspot.de/2013/04/how-to-deploy-elasticsearch-cluster.html</a></li>
				<li><a href="http://www.elasticsearch.org/guide/reference/modules/node.html" target="_blank">http://www.elasticsearch.org/guide/reference/modules/node.html</a></li>
			</ul>

			<blockquote>accepted</blockquote>

			<p>&nbsp;</p>

			<p>The master node is the same as any other node in the cluster, except that it has been elected to be the master.</p>

			<p>It is responsible for coordinating any cluster-wide changes, such as as the addition or removal of a node, creation, deletion or change of state (ie open/close) of an index, and the allocation of shards to nodes. When any of these changes occur, the &quot;cluster state&quot; is updated by the master and published to all other nodes in the cluster. It is the only node that may publish a new cluster state.</p>

			<p>The tasks that a master performs are lightweight. Any tasks that deal with data (eg indexing, searching etc) do not need to involve the master. If you choose to run the master as a non-data node (ie a node that acts as master and as a router, but doesn&#39;t contain any data) then the master can run happily on a smallish box.</p>

			<p>A node is allowed to become a master if it is marked as &quot;master eligible&quot; (which all nodes are by default). If the current master goes down, a new master will be elected by the cluster.</p>

			<p>An important configuration option in your cluster is minimum_master_nodes. This specifies the number of &quot;master eligible&quot; nodes that a node must be able to see in order to be part of a cluster. Its purpose is to avoid &quot;split brain&quot; ie having the cluster separate into two clusters, both of which think that they are functioning correctly.</p>

			<p>For instance, if you have 3 nodes, all of which are master eligible, and set minimum_master_nodes to 1, then if the third node is separated from the other two it, it still sees one master-eligible node (itself) and thinks that it can form a cluster by itself.</p>

			<p>Instead, set minimum_master_nodes to 2 in this case (number of nodes / 2 + 1), then if the third node separates, it won&#39;t see enough master nodes, and thus won&#39;t form a cluster by itself. It will keep trying to join the original cluster.</p>

			<p>While Elasticsearch tries very hard to choose the correct defaults, minimum_master_nodes is impossible to guess, as it has no way of knowing how many nodes you intend to run. This is something you must configure yourself.</p>
			</div>
			</div>
			</td>
		</tr>
		<tr>
		</tr>
	</tbody>
</table>
</div>
',
    'resized_imgs' => 
    array (
    ),
    'modified' => 1392640141,
    'modified_by' => 'admin',
  ),
);

