<?php
defined('is_running') or die('Not an entry point...');
$fileVersion = '4.3.2';
$fileModTime = '1393159776';
$file_stats = array (
  'created' => 1392316385,
  'gpversion' => '4.3.2',
  'modified' => 1393159776,
  'username' => 'admin',
);

$meta_data = array (
  'file_number' => 33,
  'file_type' => 'text',
);

$file_sections = array (
  0 => 
  array (
    'type' => 'text',
    'content' => '<div id="wikipage">
<table>
	<tbody>
		<tr>
			<td>
			<div id="wikiheader"><span style="font-size:120%;font-weight:bold">Administration</span> &nbsp;
			<div><i>Administration Guide</i></div>
			</div>

			<div id="wikicontent">
			<div class="vt" id="wikimaincol">
			<h1><a name="Introduction"></a>Introduction</h1>

			<h1><a name="Details"></a>Details</h1>

			<h2><a name="Supported_web_browsers"></a>Supported web browsers</h2>

			<p>ELMA user and admin interfaces should work in all modern web browsers as long as they support SVG:</p>

			<ul>
				<li>Tested with <strong>Firefox &gt; 19.x</strong>.</li>
				<li><strong>IE8 &amp; IE9 don&#39;t work correctly!</strong></li>
			</ul>

			<p>&nbsp;</p>

			<h2><a name="ELMA_admin_interfaces"></a>ELMA admin interfaces</h2>

			<pre class="prettyprint">
https://syslog.elma.org/elasticsearch.html</pre>

			<p>For example, if you are running ES node on syslog.elma.org:9443 then you can navigate your browser to <a href="https://syslog.elma.org:9443/_plugin/bigdesk/" target="_blank">https://syslog.elma.org:9443/_plugin/bigdesk/</a> and Bigdesk will auto connect to existing node.</p>

			<pre class="prettyprint">
https://syslog.elma.org:9443/_plugin/head/</pre>

			<ul>
				<li><a href="/data/_uploaded/image/wiki/elasticsearch-head.png">ElasticSearch Head</a> - Browsing and interacting with an ElasticSearch clusters</li>
			</ul>

			<blockquote>By default Head will immediately attempt to connect to a cluster node at <a href="http://syslog.elma.org:9443/" target="_blank">http://syslog.elma.org:9443/</a>. Enter a different node address in the connect box and click &#39;Connect&#39; if required.</blockquote>

			<blockquote>Head has a four major operations:
			<ul>
				<li>A cluster overview, which shows the topology of your cluster and allows you to perform index and node level operations</li>
				<li>A couple of search interfaces that allow you to query the cluster a retrieve results in raw json or tabular format</li>
				<li>Several quick access tabs that show the status of the cluster</li>
				<li>An input section that allows arbitrary call to the RESTful API to be made. This interface includes several options that can be combined to produce interesting results;
				<ul>
					<li>Select request method (get, put, post, delete), json query data, node, and path</li>
					<li>JSON validator</li>
					<li>Ability to repeat requests on a timer</li>
					<li>Ability to transform the result using javascript expressions</li>
					<li>Ability to collect results over time (using timer), or compare results</li>
					<li>Ability to chart the transformed results in a simple bar graph (including time series)</li>
				</ul>
				</li>
			</ul>
			ATTENTION: <strong>You can destroy and corrupt data</strong> from this interface if you are not careful.</blockquote>

			<pre class="prettyprint">
https://syslog.elma.org:9443/_plugin/paramedic/</pre>

			<ul>
				<li><a href="/data/_uploaded/image/wiki/elasticsearch-paramedic.png">ElasticSearch Paramedic</a> - Monitors and inspect ElasticSearch clusters</li>
			</ul>

			<blockquote>Paramedic displays real-time statistics and information about your ElasticSearch nodes and indices, as well as shard allocation within the cluster.</blockquote>

			<blockquote>Basic information about your cluster:
			<ul>
				<li>cluster name, health</li>
				<li>number of nodes and shards</li>
				<li>etc.</li>
			</ul>
			</blockquote>

			<blockquote>Stats displays key metrics from the Nodes Stats API, updated every second.</blockquote>

			<blockquote>Nodes displays the most important information about the cluster nodes (used disk space and memory, number of nodes, machine load and ElasticSearch CPU consumption, etc.).</blockquote>

			<blockquote>Indices displays basic information about the indices:
			<ul>
				<li>number of primary shards</li>
				<li>number of replicas</li>
				<li>basic index statistics, using the Cluster State, Indices Status and Indices Stats APIs</li>
			</ul>
			</blockquote>

			<blockquote>Primary shards are displayed in blue, allocated replicas in green, unassigned replicas in yellow, and unassigned (missing) primary shards in red.</blockquote>

			<blockquote>To display shard allocation across the nodes, use the â&euro;œShow Detailsâ&euro; button.</blockquote>

			<blockquote>All information is updated periodically, which allows you to see node and index statistics, shard initialization or relocation, etc. in real time.</blockquote>

			<pre class="prettyprint">
https://syslog.elma.org:9443/_plugin/bigdesk/</pre>

			<ul>
				<li><a href="/data/_uploaded/image/wiki/elasticsearch-bigdesk.png">ElasticSearch BigDesk</a> - Live charts and statistics for ElasticSearch clusters</li>
			</ul>

			<blockquote>With BigDesk you can connect to a particular ElasticSearch host:
			<ul>
				<li>You should see cluster name and list of its nodes</li>
				<li>You can switch between nodes in the cluster</li>
				<li>New nodes are added and old nodes are removed automatically on the fly</li>
				<li>You can change the Bigdesk refresh interval and amount of data that is displayed by charts</li>
			</ul>
			</blockquote>

			<h2><a name="ELMA_user_management"></a>ELMA user management</h2>

			<pre class="prettyprint">
cat /opt/elasticsearch/config/realm.properties
admin: biglog,admin,readwrite
elma: MD5:d0009403fd057dd748aa452c1e7f56b0,readwrite</pre>

			<pre class="prettyprint">
You have to edit the above Jetty realm.properties file in ElasticSearch config folder.</pre>

			<pre class="prettyprint">
java -cp /opt/elasticsearch/plugins/jetty/jetty-util-8.1.4.v20120524.jar org.eclipse.jetty.util.security.Password
Usage - java org.eclipse.jetty.security.Password [&lt;user&gt;] &lt;password&gt;</pre>

			<pre class="prettyprint">
java -cp /opt/elasticsearch/plugins/jetty/jetty-util-8.1.4.v20120524.jar org.eclipse.jetty.util.security.Password elma fjg892345sdfsdwf
fjg892345sdfsdwf
OBF:1thb1xma1taa1mx01kk21irx1lxb19xa19xc1m0v1iup1kmk1n0a1ta41xn01thb
MD5:d0009403fd057dd748aa452c1e7f56b0
CRYPT:elXAfnUGX.kHs
Now you can cut and paste whichever secure version you choose into your Jetty realm.properties file.</pre>

			<pre class="prettyprint">
#!/bin/sh
#
# author: Joerg Heinemann
# website: http://code.google.com/p/enterprise-log-management-appliance/
# license: GPL v3
# date: 2013-01-10
# version: 0.0.30
#
# /opt/elma/bin/install/update-jetty-user-password.sh
#
if [ ! $2 ]; then
  echo $(basename $0): Error: No username or password specified &gt;&amp;2
  echo &quot;$(basename $0): Usage: $(basename $0) &lt;username&gt; &lt;password&gt;&quot; &gt;&amp;2
  exit 1
fi
# Update ElasticSearch Jetty users MD5 hashed password
# ######### Get ELMA configuration parameter #########
#
source /opt/elma/config/elma/elma.conf
# ######### MD5 hashed password using Jetty Password Utility #########
#
HASH=$(java -cp /opt/elasticsearch/plugins/jetty/jetty-util-8.1.4.v20120524.jar org.eclipse.jetty.util.security.Password $1 $2 2&gt;&amp;1 | grep MD5)
# ######### Update ElasticSearch Jetty realm.properties #########
#
sed -i.$(date +%Y%m%d) -e &#39;/^&#39;$1&#39;:/s/: [^,]*,/: &#39;$HASH&#39;,/&#39; /opt/elasticsearch/config/realm.properties</pre>

			<pre class="prettyprint">
cat /opt/elma/config/elma/elma.conf
# author: Joerg Heinemann
# website: http://code.google.com/p/enterprise-log-management-appliance/
# license: GPL v3
# date: 2013-01-10
# version: 0.0.30
#
# /opt/elma/config/elma/elma.conf
#
# ######### Set ElasticSearch host #########
#
ESHOST=&quot;localhost&quot;
# ######### Set ElasticSearch Jetty http communication #########
#
ESPROTOCOL=&quot;http&quot;
ESPORT=&quot;9200&quot;
# ######### Set ElasticSearch Jetty https/ssl communication #########
#
#ESPROTOCOL=&quot;https&quot;
#ESPORT=&quot;9443&quot;
# ######### Set ElasticSearch URL #########
#
ESURL=&quot;--insecure $ESPROTOCOL://$ESHOST:$ESPORT&quot;
# ######### Set ElasticSearch Jetty service UID and password #########
#
ESUID=&quot;elma&quot;
ESPWD=&quot;fjg892345sdfsdwf&quot;
# ######### Enable curl basic authentication #########
#
#ESAUTH=&quot;-u $ESUID:$ESPWD&quot;
# ######### Disable curl basic authentication #########
#
ESAUTH=&quot;&quot;
# ######### Set the number of days ElasticSearch indexes should be hold #########
#
ARCHIVEPERIOD=&quot;7&quot;</pre>

			<ul>
				<li>ElasticSearch basic authentication - <a href="https://github.com/sonian/elasticsearch-jetty#readme" target="_blank">Jetty plugin</a></li>
				<li>Add Jetty User or change Jetty Group</li>
				<li>The passwords should be obfuscated or MD5 hashed using <a href="http://wiki.eclipse.org/Jetty/Howto/Secure_Passwords" target="_blank">Jetty Password Utility</a></li>
				<li>ElasticSearch Jetty Passwd User Interface</li>
				<li>ElasticSearch Jetty service UID and password</li>
			</ul>
			</div>
			</div>
			</td>
		</tr>
		<tr>
		</tr>
	</tbody>
</table>
</div>
',
    'resized_imgs' => 
    array (
    ),
    'modified' => 1392638934,
    'modified_by' => 'admin',
  ),
);

