<?php
defined('is_running') or die('Not an entry point...');
$fileVersion = '4.3.2';
$fileModTime = '1393159783';
$file_stats = array (
  'created' => 1392316385,
  'gpversion' => '4.3.2',
  'modified' => 1393159783,
  'username' => 'admin',
);

$meta_data = array (
  'file_number' => 33,
  'file_type' => 'text',
);

$file_sections = array (
  0 => 
  array (
    'type' => 'text',
    'content' => '<div id="wikipage">
<table>
	<tbody>
		<tr>
			<td>
			<div id="wikiheader"><span style="font-size:120%;font-weight:bold">Operation</span> &nbsp;
			<div><i>Operation Guide</i></div>
			</div>

			<div id="wikicontent">
			<div class="vt" id="wikimaincol">
			<h1><a name="Introduction"></a>Introduction</h1>

			<p>This HOWTO describes a range of potential common problems and their solutions.<br />
			If your situation is not precisely listed here, there may be one on <a href="http://doc.opensuse.org/documentation/html/openSUSE/opensuse-startup/bk01apa.html" target="_blank">openSUSE Help and Troubleshooting</a> site.</p>

			<p>For more detailed installation instructions and deployment strategies, see the openSUSE documentation at <a href="http://doc.opensuse.org/" target="_blank">http://doc.opensuse.org/</a>.</p>

			<h1><a name="Details"></a>Details</h1>

			<p>ELMA appliance comes out of the box without any Linux graphical user interface. Therefore it is useful to have some basic knowledge of working with <a href="http://doc.opensuse.org/documentation/html/openSUSE/opensuse-security/cha.ssh.html" target="_blank">OpenSSH utilities</a> and Linux shell because some operation and administration tasks only can be done with shell commands.</p>

			<h2><a name="Secure_Network_Operations"></a>Secure Network Operations</h2>

			<p>In networked environments, it is often necessary to access hosts from a remote location. The SSH implementation coming with openSUSE is OpenSSH and provides the necessary protection by encrypting the authentication strings (usually a login name and a password) and all the other data exchanged between the hosts.</p>

			<p>openSUSE installs the OpenSSH package by default providing the commands:</p>

			<pre class="prettyprint">
ssh, scp, and sftp</pre>

			<p>In the default configuration, remote access of a openSUSE system is only possible with the OpenSSH utilities, and only if the sshd is running and the firewall permits access.</p>

			<h2><a name="Secure_Shell"></a>Secure Shell</h2>

			<p>By using the ssh program, it is possible to log in to remote systems and to work interactively. To log in to the host elma as user tux use one of the following commands:</p>

			<pre class="prettyprint">
ssh tux@elma
ssh -l tux elma</pre>

			<p>If the username is the same on both machines, you may omit it:</p>

			<pre class="prettyprint">
ssh elma</pre>

			<p>The remote host prompts for the remote user&#39;s password. After a successful authentication, you can work on the remote command line or use interactive applications, such as YaST in text mode.</p>

			<p>The default shell in openSUSE is Bash (GNU Bourne-Again Shell).</p>

			<h2><a name="SNMP_trap_generation_for_specific_testing"></a>SNMP trap generation for specific testing</h2>

			<pre class="prettyprint">
snmptrap -v 1 -c public 127.0.0.1 .1.3.6.1 localhost 6 17 &#39;&#39; .1.3.6.1 s &quot;Just a test ;-)&quot;</pre>

			<ul>
				<li>net-snmp tools</li>
			</ul>

			<h2><a name="Syslog_event_generation_for_specific_testing"></a>Syslog event generation for specific testing</h2>

			<pre class="prettyprint">
tcpflood -X -m2 -R2 -S1 -t127.0.0.1 -Ttcp -p514
00001 open connections
starting run 1
Sending 2 messages.
00000002 messages sent
runtime: 0.001
sleeping 1 seconds before next run
starting run 2
Sending 2 messages.
00000002 messages sent
runtime: 0.000
Runs:     2
Runtime:
  total:  0.001
  avg:    0.000
  min:    0.000
  max:    0.001
All times are wallclock time.
00001 close connections
End of tcpflood Run</pre>

			<ul>
				<li><a href="http://www.rsyslog.com/doc/node18.html" target="_blank">rsyslog traffic generator</a> - rsyslog test and benchmark suite</li>
				<li><a href="http://www.kiwisyslog.com/downloads.aspx" target="_blank">Kiwi SyslogGen</a> - a Free Syslog message generator for Windows</li>
			</ul>

			<p>Results of <a href="/wiki/Tests.html">Test and performance tuning</a>.</p>

			<h2><a name="Basic_operations"></a>Basic operations</h2>

			<h3><a name="Time_synchronization"></a>Time synchronization</h3>

			<p>Wrong timpstamp in ELMA Search-Gui - Is your system time synchronized and up to date?</p>

			<p>One of the quickest commands to verify that ntpd is still up and running as desired is:</p>

			<pre class="prettyprint">
ntpq -p</pre>

			<p>To compare time offsets between local system time and time taken from your ntp server:</p>

			<pre class="prettyprint">
ntpdate -d server</pre>

			<p>To synchronize your system time manually:</p>

			<pre class="prettyprint">
systemctl stop ntp.service
ntpdate server
systemctl start ntp.service</pre>

			<h3><a name="Delete_and_optimize_of_time-based_indices"></a>Delete and optimize of time-based indices</h3>

			<p>Old time-based indices logs have to be removed in a nightly cron job.</p>

			<p>Optimizing indices is also a good thing to do at off-peak times, because it improves your search speed. This is recommended especially when you have time-based indices, because (with the exception of the â&euro;œcurrentâ&euro; one) they never change, so you only have to do this once on an â&euro;œoldâ&euro; index.</p>

			<pre class="prettyprint">
/opt/elma/bin/cron.daily/elma_elasticsearch_daily.sh
===========================================================================================
Cronjob    : elma_elasticsearch_daily
-------------------------------------------------------------------------------------------
Description: elasticsearch index optimization
Author     : Joerg Heinemann
Website    : http://code.google.com/p/enterprise-log-management-appliance/
===========================================================================================
--- 08:28:42.172 - show todays 2013-01-11 elasticsearch indexes ---------------------------
rsyslog-2013-01-11
--- 08:28:42.207 - show yesterdays 2013-01-10 elasticsearch indexes -----------------------
rsyslog-2013-01-10
--- 08:28:42.228 - show all elasticsearch indexes -----------------------------------------
rsyslog-1970-01-01
rsyslog-2012-12-31
rsyslog-2013-01-08
rsyslog-2013-01-09
rsyslog-2013-01-10
rsyslog-2013-01-11
--- 08:28:42.248 - delete elasticsearch indexes -------------------------------------------
--- 08:28:42.268 - delete index with screwed-up timestamps: rsyslog-1970-01-01
{&quot;ok&quot;:true,&quot;acknowledged&quot;:true}
--- 08:28:42.359 - delete index with expired timestamps (&lt; 2013-01-04): rsyslog-2012-12-31
{&quot;ok&quot;:true,&quot;acknowledged&quot;:true}
--- 08:28:42.444 - optimize elasticsearch indexes -----------------------------------------
--- 08:28:42.467 - optimizing: rsyslog-2013-01-10
{&quot;ok&quot;:true,&quot;_shards&quot;:{&quot;total&quot;:1,&quot;successful&quot;:1,&quot;failed&quot;:0}}
--- 08:28:42.484 - exit -------------------------------------------------------------------
===========================================================================================
Last log archive:               2013-01-04
Days in log archive:            7
Actual number of indexes:       4
===========================================================================================</pre>

			<ul>
				<li>ElasticSearch index optimization</li>
			</ul>

			<h3><a name="ELMA_reconfigure_and_restart"></a>ELMA reconfigure and restart</h3>

			<pre class="prettyprint">
elma-es:~ # /opt/elma/bin/install/elma-reconfigure.sh
===========================================================================================
Scriptname : elma-reconfigure.sh
-------------------------------------------------------------------------------------------
Version    : 0.0.186
Library    : elma-global-functions.sh
Path       : /opt/elma-0.0.186/bin/install
Log file   : /var/log/elma/elma-reconfigure-2013-07-04-19:38:33.log
Description: Reconfigure ELMA after configuration changes
Author     : Joerg Heinemann
Website    : http://code.google.com/p/enterprise-log-management-appliance
===========================================================================================
...
===========================================================================================
PASS: Reconfiguring process was successful
===========================================================================================
Appliance build:
----------------
Enterprise_Log_Management_Appliance-0.0.178 (2013-06-18)
Based on openSUSE 12.3 (Dartmouth) (x86_64) (2013-02-08)
Installed versions:
-------------------
ELMA              : 0.0.186 (2013-07-04)
Kibana            : v0.2.0-125-g8654bdd (2013-06-17)
Kibana dashboard  : 4f1b33b (2013-06-21)
ElasticSearch     : 0.90.0 (2013-04-25) - running with PID 1476
rsyslog           : 7.2.7-2.5.1.x86_64 (2013-04-29) - running with PID 6561
rsyslog testtools : 7.2.7 (2013-05-09)
Nagios Core       : 3.5.0-79.1.x86_64 (2013-06-28) - running with PID 6207
apache            : 2.2.22-10.4.1.x86_64 (2013-03-28) - running with PID 6410
Update Recommendations:
-----------------------
</pre>

			<ul>
				<li>Distribution script elma-reconfigure</li>
			</ul>

			<h3><a name="systemd_system_and_service_manager"></a>systemd system and service manager</h3>

			<p>Starting with openSUSE 12 <a href="http://doc.opensuse.org/documentation/html/openSUSE/opensuse-reference/cha.systemd.html" target="_blank">systemd</a> is a replacement for the popular SysV init daemon.</p>

			<p>The program systemd is the process with process ID 1. It is responsible for initializing the system in the required way. systemd is started directly by the Kernel and resists signal 9, which normally kills processes. All other programs are either started directly by systemd or by one of its child processes.</p>

			<pre class="prettyprint">
systemctl [ enable | disable | start | stop | restart | reload | status ] &lt;my_service(s)&gt;.service </pre>

			<pre class="prettyprint">
systemctl status apache2.service
apache2.service - apache
          Loaded: loaded (/lib/systemd/system/apache2.service; enabled)
          Active: active (running) since Thu, 2013-07-04 19:04:47 CEST; 11min ago
         Process: 1430 ExecStart=/usr/sbin/start_apache2 -D SYSTEMD -k start (code=exited, status=0/SUCCESS)
        Main PID: 1861 (httpd2-prefork)
          CGroup: name=systemd:/system/apache2.service
                  Ã&cent; 1861 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
                  Ã&cent; 1910 PassengerWatchdog
                  Ã&cent; 1913 PassengerHelperAgent
                  Ã&cent; 1915 Passenger spawn server
                  Ã&cent; 1918 PassengerLoggingAgent
                  Ã&cent; 1927 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
                  Ã&cent; 1928 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
                  Ã&cent; 1929 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
                  Ã&cent; 1930 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
                  Ã&cent; 1931 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
Jul 04 19:04:47 elma-es.fritz.box systemd[1]: Started apache.</pre>

			<pre class="prettyprint">
systemctl status nagios.service
nagios.service - LSB: Network monitor Nagios
          Loaded: loaded (/etc/init.d/nagios)
          Active: active (running) since Thu, 2013-07-04 19:04:47 CEST; 12min ago
         Process: 1717 ExecStart=/etc/init.d/nagios start (code=exited, status=0/SUCCESS)
          CGroup: name=systemd:/system/nagios.service
                  Ã&cent; 1899 /usr/sbin/nagios -d /etc/nagios/nagios.cfg
Jul 04 19:10:37 elma-es.fritz.box nagios[1899]: SERVICE ALERT: elma-es.fritz.box;NTP Peer;CRITICAL;HARD;4;NTP CRITICAL: Server not synchronized, Offset unknown
Jul 04 19:10:37 elma-es.fritz.box nagios[1899]: SERVICE FLAPPING ALERT: elma-es.fritz.box;NTP Peer;STARTED; Service appears to have started flapping (23....hreshold)
Jul 04 19:11:17 elma-es.fritz.box nagios[1899]: SERVICE ALERT: elma-es.fritz.box;Syslog Queue;UNKNOWN;HARD;4;**ePN /usr/lib/nagios/plugins/check_files.pl...ne 755,&quot;.
Jul 04 19:11:17 elma-es.fritz.box nagios[1899]: SERVICE NOTIFICATION: nagiosadmin;elma-es.fritz.box;Syslog Queue;UNKNOWN;notify-service-by-email;**ePN /u...ine 755,.
Jul 04 19:11:17 elma-es.fritz.box nagios[1899]: SERVICE NOTIFICATION: admin;elma-es.fritz.box;Syslog Queue;UNKNOWN;notify-service-by-email;**ePN /usr/lib...ine 755,.
Jul 04 19:13:37 elma-es.fritz.box sudo[2918]: pam_unix(sudo:auth): conversation failed
Jul 04 19:13:37 elma-es.fritz.box sudo[2918]: pam_unix(sudo:auth): auth could not identify password for [root]
Jul 04 19:13:47 elma-es.fritz.box nagios[1899]: SERVICE ALERT: elma-es.fritz.box;Network Interfaces;OK;HARD;4;eth0:UP (0.0Mbps/0.0Mbps/0.0/0.0/24.0/0.0):(1 UP): OK
Jul 04 19:13:47 elma-es.fritz.box nagios[1899]: SERVICE FLAPPING ALERT: elma-es.fritz.box;Network Interfaces;STARTED; Service appears to have started fla...hreshold)
Jul 04 19:15:37 elma-es.fritz.box nagios[1899]: SERVICE ALERT: elma-es.fritz.box;NTP Peer;WARNING;HARD;4;NTP WARNING: Server has the LI_ALARM bit set, Of...0967 secs</pre>

			<pre class="prettyprint">
systemctl status elasticsearch.service
elasticsearch.service - elasticsearch
          Loaded: loaded (/usr/lib/systemd/system/elasticsearch.service; enabled)
          Active: active (running) since Thu, 2013-07-04 19:04:45 CEST; 14min ago
            Docs: http://www.elasticsearch.org
         Process: 1429 ExecStart=/opt/elasticsearch-0.90.0/bin/elasticsearch -p /var/run/elasticsearch.pid -Des.max-open-files=true -Des.bootstrap.mlockall=true -Des.cluster.name=$ES_CLUSTER_NAME -Des.node.name=$ES_NODE_NAME -Des.config=$CONF_FILE -Des.path.home=$ES_HOME -Des.path.logs=$LOG_DIR -Des.path.data=$DATA_DIR -Des.path.work=$WORK_DIR -Des.path.conf=$CONF_DIR -Des.path.plugins=$ES_PLUGIN_DIR (code=exited, status=0/SUCCESS)
        Main PID: 1476 (java)
          CGroup: name=systemd:/system/elasticsearch.service
                  Ã&cent; 1476 java -Xms2g -Xmx2g -Xss256k -Djava.awt.headless=true -XX:+UseParNewGC -XX:+UseConcMarkSweepGC -XX:CMSInitiatingOccupancyFraction=75 -XX...
Jul 04 19:04:45 elma-es.fritz.box systemd[1]: Starting elasticsearch...
Jul 04 19:04:45 elma-es.fritz.box systemd[1]: Started elasticsearch.
Jul 04 19:04:52 elma-es.fritz.box elasticsearch[1429]: [2013-07-04 19:04:52,006][INFO ][bootstrap                ] max_open_files [63974]</pre>

			<pre class="prettyprint">
systemctl status rsyslog.service
rsyslog.service - System Logging Service
          Loaded: loaded (/usr/lib/systemd/system/rsyslog.service; enabled)
          Active: active (running) since Thu, 2013-07-04 19:04:42 CEST; 15min ago
         Process: 482 ExecStartPre=/usr/sbin/rsyslog-service-prepare (code=exited, status=0/SUCCESS)
        Main PID: 497 (rsyslogd)
          CGroup: name=systemd:/system/rsyslog.service
                  Ã&cent; 497 /usr/sbin/rsyslogd -n
Jul 04 19:04:42 elma-es.fritz.box systemd[1]: Started System Logging Service.</pre>

			<ul>
				<li>Basic Usage</li>
				<li>Managing main ELMA services</li>
			</ul>

			<h3><a name="openSUSE_firewall"></a>openSUSE firewall</h3>

			<p>Stop/Start/Restart</p>

			<pre class="prettyprint">
systemctl stop SuSEfirewall2.service
systemctl start SuSEfirewall2.service
systemctl restart SuSEfirewall2.service</pre>

			<h3><a name="Process_table"></a>Process table</h3>

			<pre class="prettyprint">
ps -ef</pre>

			<pre class="prettyprint">
ps -ef | grep syslog
root       515     1  0 18:31 ?        00:00:00 /usr/sbin/rsyslogd -n</pre>

			<pre class="prettyprint">
ps -ef | grep elasticsearch
elastic+  1664     1  2 18:32 ?        00:00:43 java -Xms2g -Xmx2g -Xss256k -Djava.awt.headless=true -XX:+UseParNewGC -XX:+UseConcMarkSweepGC -XX:CMSInitiatingOccupancyFraction=75 -XX:+UseCMSInitiatingOccupancyOnly -XX:+HeapDumpOnOutOfMemoryError -Delasticsearch -Des.pidfile=/var/run/elasticsearch.pid -Des.path.home=/opt/elasticsearch-0.90.0 -cp :/opt/elasticsearch-0.90.0/lib/elasticsearch-0.90.0.jar:/opt/elasticsearch-0.90.0/lib/*:/opt/elasticsearch-0.90.0/lib/sigar/* -Des.max-open-files=true -Des.bootstrap.mlockall=true -Des.cluster.name=elma -Des.node.name=elma-es.fritz.box -Des.config=/etc/elasticsearch/elasticsearch.yml -Des.path.home=/opt/elasticsearch-0.90.0 -Des.path.logs=/var/log/elasticsearch -Des.path.data=/data -Des.path.work=/data/tmp -Des.path.conf=/etc/elasticsearch -Des.path.plugins=/opt/elasticsearch-0.90.0/plugins org.elasticsearch.bootstrap.ElasticSearch</pre>

			<pre class="prettyprint">
ps -l --cols 20000 1664
F S   UID   PID  PPID  C PRI  NI ADDR SZ WCHAN  TTY        TIME CMD
0 S   490  1664     1  2  80   0 - 764600 futex_ ?         0:43 java -Xms2g -Xmx2g -Xss256k -Djava.awt.headless=true -XX:+UseParNewGC -XX:+UseConcMarkSweepGC -XX:CMSInitiatingOccupancyFraction=75 -XX:+UseCMSInitiatingOccupancyOnly -XX:+HeapDumpOnOutOfMemoryError -Delasticsearch -Des.pidfile=/var/run/elasticsearch.pid -Des.path.home=/opt/elasticsearch-0.90.0 -cp :/opt/elasticsearch-0.90.0/lib/elasticsearch-0.90.0.jar:/opt/elasticsearch-0.90.0/lib/*:/opt/elasticsearch-0.90.0/lib/sigar/* -Des.max-open-files=true -Des.bootstrap.mlockall=true -Des.cluster.name=elma -Des.node.name=elma-es.fritz.box -Des.config=/etc/elasticsearch/elasticsearch.yml -Des.path.home=/opt/elasticsearch-0.90.0 -Des.path.logs=/var/log/elasticsearch -Des.path.data=/data -Des.path.work=/data/tmp -Des.path.conf=/etc/elasticsearch -Des.path.plugins=/opt/elasticsearch-0.90.0/plugins org.elasticsearch.bootstrap.ElasticSearch</pre>

			<pre class="prettyprint">
ps -ef | grep apache
root      1884     1  0 18:32 ?        00:00:00 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
wwwrun    1910  1884  0 18:32 ?        00:00:00 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
wwwrun    1911  1884  0 18:32 ?        00:00:00 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
wwwrun    1912  1884  0 18:32 ?        00:00:00 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
wwwrun    1913  1884  0 18:32 ?        00:00:00 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start
wwwrun    1914  1884  0 18:32 ?        00:00:00 /usr/sbin/httpd2-prefork -f /etc/apache2/httpd.conf -DSSL -D SYSTEMD -k start</pre>

			<pre class="prettyprint">
ps -ef | grep nagios
nagios    1679     1  0 18:32 ?        00:00:00 /usr/sbin/nrpe -c /etc/nrpe.cfg -d
nagios    1915     1  0 18:32 ?        00:00:02 /usr/sbin/nagios -d /etc/nagios/nagios.cfg</pre>

			<ul>
				<li>View all <strong>running processes</strong></li>
				<li>rsyslogd process</li>
				<li>ElasticSearch JAVA process</li>
				<li>Apache2 processes</li>
				<li>Nagios processes</li>
			</ul>

			<h3><a name="Log_files"></a>Log files</h3>

			<p>There are several places to look when you encounter problems with your system. Following a list of the most frequently checked log files follows with the description of their typical purpose.</p>

			<pre class="prettyprint">
/var/log/boot.msg - Messages from the kernel reported during the boot process
/var/log/messages - Ongoing messages from the kernel and system log daemon (when running)
/var/log/warn - All messages from the kernel and system log daemon with the â&euro;œwarningâ&euro; level or higher
/var/log/wtmp - Binary file containing user login records for the current machine session (View it with last)
/var/log/YaST2/ - Directory containing YaST&#39;s actions and their results
/var/log/zypper.log - Log file of zypper</pre>

			<pre class="prettyprint">
/var/log/apache2/access_log
/var/log/apache2/error_log
/var/log/apache2/ssl_request_log</pre>

			<pre class="prettyprint">
/var/log/elasticsearch/elma.log
/var/log/elasticsearch/elma_index_indexing_slowlog.log
/var/log/elasticsearch/elma_index_search_slowlog.log</pre>

			<pre class="prettyprint">
/var/log/elma/</pre>

			<pre class="prettyprint">
/var/log/nagios/</pre>

			<ul>
				<li>Operation system</li>
				<li>Apache2</li>
				<li>ElasticSearch</li>
				<li>ELMA installation</li>
				<li>Nagios</li>
			</ul>

			<h3><a name="Storage_devices_and_disk_partitions"></a>Storage devices and disk partitions</h3>

			<pre class="prettyprint">
cat /proc/partitions
major minor  #blocks  name
 253        0   25165824 vda
 253        1     204804 vda1
 253        2   24959996 vda2
 253       16   16567296 vdb
 252        0    4194304 dm-0
 252        1    8392704 dm-1
 252        2    4194304 dm-2
 252        3    8175616 dm-3
 252        4   16564224 dm-4</pre>

			<pre class="prettyprint">
parted /dev/vda &#39;print&#39;
Model: Virtio Block Device (virtblk)
Disk /dev/vda: 25.8GB
Sector size (logical/physical): 512B/512B
Partition Table: msdos
Number  Start   End     Size    Type     File system  Flags
 1      1049kB  211MB   210MB   primary  ext3         boot, type=83
 2      211MB   25.8GB  25.6GB  primary               lvm, type=8e</pre>

			<ul>
				<li>View all <strong>available storage devices</strong> attached to your appliance</li>
				<li>View all available partitions using <a href="http://www.thegeekstuff.com/2011/09/parted-command-examples/" target="_blank">parted command</a></li>
				<li><a href="http://www.thegeekstuff.com/2010/09/linux-fdisk/" target="_blank">fdisk -l</a> also works pretty well</li>
			</ul>

			<h3><a name="Logical_Volume_Manager_(LVM)"></a>Logical Volume Manager (LVM)</h3>

			<pre class="prettyprint">
pvcreate /dev/sdb1    
  Physical volume &quot;/dev/sdb1&quot; successfully created</pre>

			<pre class="prettyprint">
vgscan
  Reading all physical volumes.  This may take a while...
  Found volume group &quot;systemVG&quot; using metadata type lvm2</pre>

			<pre class="prettyprint">
lvscan
  ACTIVE            &#39;/dev/systemVG/LVvar_log&#39; [4.00 GiB] inherit
  ACTIVE            &#39;/dev/systemVG/LVdata&#39; [64.00 GiB] inherit  
  ACTIVE            &#39;/dev/systemVG/LVRoot&#39; [7.91 GiB] inherit</pre>

			<pre class="prettyprint">
pvscan
  PV /dev/sda2   VG systemVG        lvm2 [75.91 GiB / 0    free]
  PV /dev/sdb1                      lvm2 [150.00 GiB]           
  Total: 2 [225.91 GiB] / in use: 1 [75.91 GiB] / in no VG: 1 [150.00 GiB]</pre>

			<pre class="prettyprint">
vgextend systemVG /dev/sdb1
  Volume group &quot;systemVG&quot; successfully extended</pre>

			<pre class="prettyprint">
vgs
  VG       #PV #LV #SN Attr   VSize   VFree    
  systemVG   2   3   0 wz--n- 225.90g 150.00g  </pre>

			<pre class="prettyprint">
lvextend  -L213G /dev/systemVG/LVdata
  Extending logical volume LVdata to 213.00 GiB
  Logical volume LVdata successfully resized</pre>

			<pre class="prettyprint">
resize2fs /dev/systemVG/LVdata
resize2fs 1.42.4 (12-June-2012)
Filesystem at /dev/systemVG/LVdata is mounted on /data; on-line resizing required
old_desc_blocks = 4, new_desc_blocks = 14
Performing an on-line resize of /dev/systemVG/LVdata to 55836672 (4k) blocks.
The filesystem on /dev/systemVG/LVdata is now 55836672 blocks long.</pre>

			<ul>
				<li>Logical Volume Manager <strong>filesystem extension</strong></li>
			</ul>

			<h3><a name="Filesystems"></a>Filesystems</h3>

			<pre class="prettyprint">
df -h
Filesystem                         Size  Used Avail Use% Mounted on
devtmpfs                           2.0G   32K  2.0G   1% /dev
tmpfs                              2.0G     0  2.0G   0% /dev/shm
tmpfs                              2.0G  201M  1.8G  11% /run
/dev/mapper/systemVG-LVRoot        7.5G  2.1G  5.0G  29% /
tmpfs                              2.0G     0  2.0G   0% /sys/fs/cgroup
tmpfs                              2.0G  201M  1.8G  11% /var/lock
tmpfs                              2.0G  201M  1.8G  11% /var/run
/dev/mapper/dataVG-LVdata           16G  179M   15G   2% /data
/dev/vda1                          199M   53M  136M  28% /boot
/dev/mapper/systemVG-LVvar_spool_  3.9G  143M  3.6G   4% /var/spool
/dev/mapper/systemVG-LVopt_        3.9G  330M  3.4G   9% /opt
/dev/mapper/systemVG-LVvar_log_    7.8G  200M  7.2G   3% /var/log</pre>

			<pre class="prettyprint">
df -ih
Filesystem                        Inodes IUsed IFree IUse% Mounted on
devtmpfs                            495K   416  494K    1% /dev
tmpfs                               496K     1  496K    1% /dev/shm
tmpfs                               496K   431  495K    1% /run
/dev/mapper/systemVG-LVRoot         1.6M   71K  1.5M    5% /
tmpfs                               496K    13  496K    1% /sys/fs/cgroup
tmpfs                               496K   431  495K    1% /var/lock
tmpfs                               496K   431  495K    1% /var/run
/dev/mapper/dataVG-LVdata          1013K   616 1012K    1% /data
/dev/vda1                            13K   564   12K    5% /boot
/dev/mapper/systemVG-LVvar_log_     1.1M  1.2K  1.0M    1% /var/log
/dev/mapper/systemVG-LVvar_spool_   512K    72  512K    1% /var/spool
/dev/mapper/systemVG-LVopt_         512K  9.7K  503K    2% /opt</pre>

			<ul>
				<li>Filesystem <strong>disk space usage</strong></li>
				<li>List <strong>inode information</strong> instead of block usage</li>
			</ul>

			<h3><a name="Check_and_Repair_Filesystems"></a>Check and Repair Filesystems</h3>

			<p><strong>fsck</strong> (file system consistency check) utility is used to <strong>check and repair filesystems</strong> (<a href="http://www.thegeekstuff.com/2011/05/ext2-ext3-ext4/" target="_blank">ext2, ext3, ext4, ...</a>). Depending on the last time of filesystem checks, the operating system runs fsck during boot time to check whether filesystems are in consistent states.</p>

			<p>You could also <a href="http://www.thegeekstuff.com/2012/08/fsck-command-examples/" target="_blank">run fsck command manually</a> when there is a problem with filesystems. <strong>Make sure to execute the fsck on an unmounted filesystems to avoid any data corruption issues.</strong></p>

			<p><strong>Note</strong>: You need to be <strong>root</strong> and <strong>console access</strong> to use any of the below mentioned commands.</p>

			<pre class="prettyprint">
init 1</pre>

			<pre class="prettyprint">
umount /data</pre>

			<pre class="prettyprint">
fsck -y /data
fsck from util-linux 2.21.2
e2fsck 1.42.6 (21-Sep-2012)
/dev/mapper/dataVG-LVdata: clean, 438/1036320 files, 110534/4141056 blocks</pre>

			<pre class="prettyprint">
fsck -a -AR</pre>

			<pre class="prettyprint">
mount /data</pre>

			<ul>
				<li>Take system down to <strong>runlevel one - no network access</strong></li>
				<li><strong>Unmount</strong> filesystem</li>
				<li>Check a specific filesystem and <strong>attempt to fix detected problems automaticly</strong></li>
				<li><strong>Automatically repair damaged portions</strong> using option -a</li>
				<li>Once fsck finished, <strong>remount</strong> filesystem</li>
			</ul>

			<pre class="prettyprint">
touch /forcefsck</pre>

			<pre class="prettyprint">
reboot</pre>

			<ul>
				<li>If you want to <strong>force fsck on the next boot</strong>, just create a file called /forcefsck</li>
				<li><strong>Reboot</strong> your system and when it comes up, fsck will be forced if /forcefsck file is present</li>
			</ul>

			<h3><a name="Five_ways_to_boot_openSUSE_when_Grub_is_broken"></a>Five ways to boot openSUSE when Grub is broken</h3>

			<p><a href="http://swerdna.dyndns.org/susebootfive.html" target="_blank">HowTo Boot into openSUSE</a> when it won&#39;t Boot from the Grub Code on the Hard Drive</p>

			<h3><a name="US_Keyboard_Layout"></a>US Keyboard Layout</h3>

			<p>Regardless of what language and keyboard layout your final installation will be using, most BIOS configurations use the US keyboard layout as depicted in the following figure:</p>

			<p><img src="/data/_uploaded/image/wiki/keyboard_us.png" alt="" /></p>
			</div>
			</div>
			</td>
		</tr>
		<tr>
		</tr>
	</tbody>
</table>
</div>
',
    'resized_imgs' => 
    array (
    ),
    'modified' => 1392640996,
    'modified_by' => 'admin',
  ),
);

