<?php
defined('is_running') or die('Not an entry point...');
$fileVersion = '4.3.4';
$fileModTime = '1398268281';
$file_stats = array (
  'created' => 1392316385,
  'gpversion' => '4.3.4',
  'modified' => 1398268281,
  'username' => 'admin',
);

$meta_data = array (
  'file_number' => 33,
  'file_type' => 'text',
);

$file_sections = array (
  0 => 
  array (
    'type' => 'text',
    'content' => '<div id="wikipage">
<table>
	<tbody>
		<tr>
			<td>
			<div id="wikiheader"><span style="font-size:120%;font-weight:bold">FAQ</span> &nbsp;
			<div><i>Frequently Asked Questions</i><br />
			<a class="label" href="http://code.google.com/p/enterprise-log-management-appliance/w/list?q=label:Featured" style="padding-top: 2px" target="_blank" title="Listed on project home page">Featured</a></div>
			</div>

			<div id="wikicontent">
			<div class="vt" id="wikimaincol">
			<p>&nbsp;</p>

			<h1><a name="Introduction"></a>Introduction</h1>

			<p><strong>Some things are simply often asked. Here we provide the answers!</strong></p>

			<p>So it is a good idea to check this area if you run into questions.<br />
			If you have questions that should be explained here, please let us know.</p>

			<p>Issues, problems, enhancements and feature requests are managed with our <a href="http://code.google.com/p/enterprise-log-management-appliance/issues/list" target="_blank">project workflow</a>.<br />
			For extended communication visit <a href="https://groups.google.com/forum/?fromgroups#!forum/enterprise-log-management-appliance" target="_blank">ELMA discussion group</a>.</p>

			<p>For syslog specific questions please also have a look at <a href="http://www.rsyslog.com/faq/" target="_blank">rsyslog</a> and <a href="http://www.balabit.com/wiki/syslog-ng-faq-table-contents" target="_blank">syslog-ng</a> FAQs.<br />
			Further informations and tips arround log management you can find in <a href="http://cookbook.logstash.net/" target="_blank">logstash cookbooks</a> and <a href="http://www.elasticsearch.org/tutorials/" target="_blank">ElasticSearch tutorials</a>.</p>

			<h1><a name="General_questions"></a>General questions</h1>

			<h4><a name="Which_web_browsers_are_supported?"></a>Which web browsers are supported?</h4>

			<blockquote>ELMA user and admin interfaces should work in all modern web browsers as long as they support SVG.</blockquote>

			<ul>
				<li>Tested with <strong>Firefox &gt; 19.x</strong>.</li>
				<li>Tested with Google Chrome 26</li>
				<li><strong>IE8 &amp; IE9 don&#39;t work correctly!</strong></li>
			</ul>

			<blockquote>You may need to <strong>clear your browsers cache after upgrading</strong> to see all of the new features.</blockquote>

			<blockquote>If you are <strong>running into ssl browser errors</strong> you may need to <strong>delete your ELMA certificate inside your browsers server certificate store</strong>.</blockquote>

			<h4><a name="File_System_Sizing_immediately_after_deployment"></a>File System Sizing immediately after deployment</h4>

			<p>A busy system will blow up <a href="/help/documentation/system-requirements">ElasticSearch or rsyslog working space</a> with data relatively quickly.</p>

			<p>A good procedure for File System Sizing immediately after deployment:</p>

			<pre class="prettyprint">
service elasticsearch stop
service rsyslogd stop</pre>

			<pre class="prettyprint">
mv /data /dataold</pre>

			<pre class="prettyprint">
chkconfig boot.lvm on</pre>

			<pre class="prettyprint">
cp -Rp /dataold/* /data</pre>

			<pre class="prettyprint">
chown -R elasticsearch:root /data</pre>

			<pre class="prettyprint">
reboot</pre>

			<ol>
				<li>Stop services</li>
				<li>Rename /data to /dataold</li>
				<li>SUSE does not auto mount non-root LVM volume groups on boot, so be sure to run</li>
				<li>Add another virtual disk, reasonably sized (I make it 100GB to start). Create a new volume group, and a new logical volume and mount it at /data</li>
				<li>Move the files from /dataold to the new /data</li>
				<li>Set the owners back, just in case</li>
				<li>Reboot</li>
			</ol>

			<h4><a name="How_do_I_limit_how_much_storage_space_is_used?"></a>How do I limit how much storage space is used?</h4>

			<blockquote>ELMA search frontend get the logging events from ElasticSearch database which stores the indexed data in /data.</blockquote>

			<pre class="prettyprint">
elma:/opt/elma/bin/install # df -h
Filesystem                         Size  Used Avail Use% Mounted on
devtmpfs                           1.9G   32K  1.9G   1% /dev
tmpfs                              1.9G     0  1.9G   0% /dev/shm
tmpfs                              1.9G  3.0M  1.9G   1% /run
/dev/mapper/systemVG-LVRoot         60G   42G   17G  72% /
tmpfs                              1.9G     0  1.9G   0% /sys/fs/cgroup
tmpfs                              1.9G  3.0M  1.9G   1% /var/lock
tmpfs                              1.9G  3.0M  1.9G   1% /var/run
/dev/sda1                          183M   35M  139M  20% /boot
/dev/mapper/systemVG-LVvar_log_     30G  3.2G   25G  12% /var/log
/dev/mapper/systemVG-LVvar_spool_   29G   16G   13G  55% /var/spool</pre>

			<pre class="prettyprint">
100 / 5 = 20</pre>

			<pre class="prettyprint">
######### Set the number of days ElasticSearch indexes should be hold #########
ESARCHIVEPERIOD=&quot;20&quot;</pre>

			<pre class="prettyprint">
/opt/elma/bin/install/elma-reconfigure.sh</pre>

			<ol>
				<li>Watch how much your logs grow in a day. For example, if /data grows from 10 GB to 15 GB in a day, this is 5 GB/day.</li>
				<li>Divide your available storage by the daily usage to determine the number of days of logs you can keep. For example, if you have 100 GB of available storage and you are using 5 GB/day, you can keep 20 days of logs.</li>
				<li>Edit &quot;/etc/elma/elma.conf&quot;</li>
				<li>Reconfigure ELMA to use new setting:</li>
			</ol>

			<h4><a name="Are_older_openSUSE_12.2_appliances_being_supported_in_future?"></a>Are older openSUSE 12.2 appliances being supported in future?</h4>

			<blockquote>There are to much changes from openSUSE 12.2 to 12.3 especially with openSUSE startup scripts and logging features. <strong>It&#39;s strongly recommended to upgrade all of your ELMA appliances</strong> (see below).</blockquote>

			<blockquote>There will be <strong>no further support for openSUSE 12.2</strong> appliances.</blockquote>

			<h4><a name="Howto_upgrade_ELMA_appliance_to_openSUSE_12.3?"></a>Howto upgrade ELMA appliance to openSUSE 12.3?</h4>

			<blockquote>Upgrade howtos can be found on <a href="http://en.opensuse.org/SDB:System_upgrade" target="_blank">openSUSE support site</a>.</blockquote>

			<blockquote>There will be <strong>no further support for openSUSE 12.2</strong> appliances. Please upgrade to openSUSE 12.3!</blockquote>

			<h4><a name="How_to_forward_syslog_events_from_syslog-ng_to_ELMA_rsyslogd?"></a>How to forward syslog events from syslog-ng to ELMA rsyslogd?</h4>

			<pre class="prettyprint">
source s_all {
  internal();
  unix-stream(&quot;/dev/log&quot;);
  file(&quot;/proc/kmsg&quot; program_override(&quot;kernel: &quot;));
};</pre>

			<pre class="prettyprint">
destination d_elma {
  tcp(&quot;192.168.0.1&quot; port(514));
};</pre>

			<pre class="prettyprint">
log { 
  source(s_all); destination(elma); 
};</pre>

			<pre class="prettyprint">
source s_all {  
  internal();  
  unix-stream(&quot;/dev/log&quot;);  
  file(&quot;/proc/kmsg&quot; program_override(&quot;kernel: &quot;));  
};
destination d_elma {
  tcp(&quot;192.168.0.1&quot; port(514));
};  
log {
  source(s_all); destination(d_elma); 
};</pre>

			<pre class="prettyprint">
/etc/init.d/syslog-ng restart</pre>

			<pre class="prettyprint">
logger &quot;my little pony&quot;</pre>

			<ol>
				<li>Edit your syslogd.conf file, usually found in /opt/syslog-ng/etc/syslogd-ng.conf and make sure you have a source called s_all:</li>
				<li>Next configure the protocol and port, and put them in a destination entry, being sure to specify TCP. Replace the &quot;192.168.0.1&quot; with the address of your ELMA server.</li>
				<li>Next tell syslog-ng to forward syslogs from &quot;s_all&quot; source to the &quot;d_elma&quot; destination. Note: This log statement must be before any &quot;final&quot; log statements, so make this the first log statement.</li>
				<li>Your configuration should now look as follows:</li>
				<li>Now, restart syslog-ng:</li>
				<li>Test sending events to ELMA by using the command line tool logger:</li>
				<li>Log into the ELMA search interface. Search for your events, starting with &quot;my little pony&quot;.</li>
			</ol>

			<h4><a name="How_to_forward_syslog_events_from_rsyslogd_to_ELMA_rsyslogd?"></a>How to forward syslog events from rsyslogd to ELMA rsyslogd?</h4>

			<blockquote>On sender site:
			<pre class="prettyprint">
# ######### Event forwarding to ELMA rsyslogd server ##########
#
# plain TCP event forwarding
#
*.* @@192.168.0.1:514</pre>
			</blockquote>

			<h4><a name="How_to_enable_compressed_event_forwarding_between_rsyslogd_serve"></a>How to enable compressed event forwarding between rsyslogd servers?</h4>

			<blockquote>On sender site:
			<pre class="prettyprint">
# ######### Compressed event forwarding to ELMA rsyslog server ##########
#
# plain TCP event forwarding with experimental framing
# maximum zlib compression rate (z1 - z9)
#
*.* @@(o,z9)192.168.0.1:514</pre>
			</blockquote>

			<blockquote>On receiver site: nothing to do</blockquote>

			<h4><a name="How_to_resolve_original_syslog_sender_IP_to_sender_hostname?"></a>How to resolve original syslog sender IP to sender hostname?</h4>

			<ul>
				<li>rsyslog @source_host value is the original sender IP.</li>
				<li>rsyslog @source value is the sender IP in front of your rsyslog server - could be the original sender IP or your syslog forwarding server.</li>
			</ul>

			<blockquote>By default rsyslogd makes reverse DNS requests to resolve the hostname and stores it instead of sender IP.<br />
			The is no further customization on ELMA appliance necessary.</blockquote>

			<blockquote>Have you to <strong>make sure that your ELMA box has right local DNS server settings!</strong></blockquote>

			<blockquote>You could test reverse DNS resolving using dig on ELMA linux shell:
			<pre class="prettyprint">
dig @localhost -x 204.152.184.167 +short</pre>
			</blockquote>

			<h4><a name="Wrong_timpstamp_in_ELMA_Search-Gui_-_Is_your_system_time_synchro"></a>Wrong timpstamp in ELMA Search-Gui - Is your system time synchronized and up to date?</h4>

			<blockquote>One of the quickest commands to verify that ntpd is still up and running as desired is:
			<pre class="prettyprint">
ntpq -p</pre>
			To compare time offsets between local system time and time taken from your ntp server:

			<pre class="prettyprint">
ntpdate -d server</pre>
			To synchronize your system time manually:

			<pre class="prettyprint">
systemctl stop ntp.service
ntpdate server
systemctl start ntp.service</pre>
			</blockquote>

			<h4><a name="UnresolvedAddressException_â€“_Have_you_setup_a_static_IP_addres"></a>UnresolvedAddressException â&euro;&ldquo; Have you setup a static IP address?</h4>

			<blockquote>In some case if you are using DHCP (dynamic or static) there is no /etc/host entry for your ELMA host. You have to insert your hostname with correspondig IP address.</blockquote>

			<blockquote>Better you change your network configuration to static for server environment. <strong>Make sure you have also correct DNS resolving (especially reverse resolving)</strong> for your appliance.</blockquote>

			<h4><a name="Rsyslog_timestamp_formatting_â€“_timestamp_parsing_problems"></a>Rsyslog timestamp formatting â&euro;&ldquo; timestamp parsing problems</h4>

			<blockquote>Rsyslog timestamp formatting:
			<pre class="prettyprint">
date-rfc3339 2010-12-05T02:21:41.889482+01:00
date-rfc3164 Dec 5 02:21:13
date-pgsql 2010-12-05 02:27:34
date-mysql 20101205022845</pre>
			</blockquote>
			</div>
			</div>
			</td>
		</tr>
		<tr>
		</tr>
	</tbody>
</table>
</div>
',
    'resized_imgs' => 
    array (
    ),
    'modified' => 1398268281,
    'modified_by' => 'admin',
  ),
);

